#!/bin/sh
echo "----------------------------------------------------------------------------"
echo "Setting up FORTE for DIGI-Connect-ME"
echo "----------------------------------------------------------------------------"
echo
echo "running on following System:"
echo `uname -a`
echo
echo "Using the gcc version:"
gcc --version
cd `pwd`
echo "Running in project directory:"
echo `pwd`
echo "----------------------------------------------------------------------------"
echo 
cd ./src/arch
rm -f active_arch
ln -s netos active_arch
cd ../../
aclocal
autoheader
automake
autoconf
cd ./bin
rm -f active_target
ln -s digime active_target
cd active_target
export FORTE_CFLAGS="-mbig-endian -mcpu=arm7tdmi"
export FORTE_CPPFLAGS="-DLOGDEBUG \
   -D__GNU__ \
   -DNETOS_GNU_TOOLS \
   -DNET_OS \
   -DNET_WORKS \
   -D_POSIX_SOURCE \
   -I`pwd`/include/ \
   -I`pwd`/include/threadx \
   -I`pwd`/include/tcpip \
   -I`pwd`/include/snmp \
   -I`pwd`/include/rphttpd \
   -I`pwd`/include/fs_intf \
   -I`pwd`/../../src/core \
   -I`pwd`/../../src/core/datatypes \
   -I`pwd`/../../src/fblib/events \
   -I`pwd`/../../src/fblib/ita \
   -I`pwd`/../../src/fblib/math \
   -I`pwd`/../../src/fblib/net"
export FORTE_CXXFLAGS="-Os -mbig-endian -mcpu=arm7tdmi"
export FORTE_LDFLAGS="-L`pwd`/lib \
   -mbig-endian -nostartfiles -nostdlib -mcpu=arm7tdmi -T image.ld"
export FORTE_LIBS="-Wl,--start-group\
   `pwd`/lib/reset.o \
   `pwd`/lib/crt0.o \
   `pwd`/lib/crti.o \
   `pwd`/lib/crtbegin.o \
   `pwd`/lib/crtend.o \
   `pwd`/lib/crtn.o \
   -lbsp -lftpsvr -lflash -lposix -ltx -ldnsclnt -lfastip -laddp -ltcpip \
   `pwd`/src/arch/active_arch/libactive_arch.a \
   -lc -lgcc -lm -lstdc++ \
   -Wl,--end-group"
../../configure --host=arm-elf