/*******************************************************************************
 * Copyright (c) 2007 4DIAC - consortium.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     <date>: <author>, <author email> - changes
 *******************************************************************************/
#ifndef _DATATYPES_H_
#define _DATATYPES_H_

/*! \ingroup FORTE-HAL
 *  \brief This are the device-independent datat types used by FORTE. 
 *  @author smr
 *  @version 20050101/smr - Initial version
 */ 

/***************************************************************************
    type definitions
***************************************************************************/

typedef unsigned char    TBYTE;             /**< 8 bit unsigned */               
typedef unsigned short   TWORD;             /**< 16 bit unsigned */
typedef unsigned long    TDWORD;            /**< 32 bit unsigned */

typedef signed char      TINT8;             /**< 8 bit signed */
typedef short            TINT16;            /**< 16 bit signed */
typedef long             TINT32;            /**< 32 bit signed */
typedef long long        TINT64;            /**< 64 bit signed */

typedef unsigned char    TUINT8;            /**< 8 bit unsigned */
typedef unsigned short   TUINT16;           /**< 16 bit unsigned */
typedef unsigned long    TUINT32;           /**< 32 bit unsigned */
typedef unsigned long long   TUINT64;       /**< 64 bit unsigned */


typedef float            TFLOAT;            /**< single precission IEEE float (32 Bit) */
typedef double           TDFLOAT;           /**< double precission IEEE float (64 bit) */

typedef bool             TBOOL8;            /**< byte variable as boolean value */

const int cg_nIdentifierLength = 32; //!<This value holds the length an identifier may have on order that it is unique. Identifiers may be FB-Type Names, FB-Names, var names,...

typedef char TIdentifier[cg_nIdentifierLength + 1]; //!<Type to hold an identifier during runtime. The +1 is for holding a trailing \\0

#endif // DATATYPES_H_
