/*******************************************************************************
 * Copyright (c) 2007 4DIAC - consortium.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     <date>: <author>, <author email> - changes
 *******************************************************************************/ 
#include "devlog.h"
#include "timerha.h"
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h> 

const int CDeviceLog::scm_nMsgBufSize = 100;  
char CDeviceLog::sm_acMsgBuf[100];

CDeviceLog::CDeviceLog(){
  m_nPos = 0;
  m_nNum = 0;
}

bool CDeviceLog::addMsg(E_MsgLevel pa_enLevel, TUINT8 pa_nSrcID, TUINT8 pa_nSubID, const char *pa_acMessage) {
  m_oSync.lock();
    
  if (CTimerHandler::sm_poFORTETimer != 0)
    fprintf(stderr,"T#%ld%ldms: ", CTimerHandler::sm_poFORTETimer->getForteTime().m_nUpperValue, CTimerHandler::sm_poFORTETimer->getForteTime().m_nLowerValue);
  else
    fprintf(stderr,"T#notime: ");
   
  switch (pa_enLevel) { 
    case E_INFO:
        fprintf(stderr,"INFO: ");
        break;
    case E_WARNING:
        fprintf(stderr,"WARNING: ");
        break;
    case E_ERROR:
        fprintf(stderr,"ERROR: ");
        break;
    case E_DEBUG:
        fprintf(stderr,"DEBUG: ");
        break;
    default:
        break;
    }
    
    fprintf(stderr, "SrcID: %d SubID: %d, :: %s\n",pa_nSrcID, pa_nSubID, pa_acMessage);

    //inserting the Log Message into the ringbuffer
   /* if (num<DEPTH) num++;
    if (pos++==DEPTH-1) pos = 0;
    MsgList[pos].pa_nSrcID = pa_nSrcID; 
    MsgList[pos].pa_nSubID = pa_nSubID; 
    MsgList[pos].Level = Level; 
    MsgList[pos].Timestamp = logtime.getValue(); 
*/
    m_oSync.unlock();
    return true;
}

bool CDeviceLog::addVarMsg(E_MsgLevel pa_enLevel, TUINT8 pa_nSrcID, TUINT8 pa_nSubID, const char *pa_acMessage, ...){
  va_list pstArgPtr;

  va_start(pstArgPtr, pa_acMessage);
  vsnprintf(sm_acMsgBuf, scm_nMsgBufSize, pa_acMessage, pstArgPtr);
  va_end(pstArgPtr);
  
  return addMsg(pa_enLevel, pa_nSrcID, pa_nSubID, sm_acMsgBuf);
}

CDeviceLog::SLogEntry &CDeviceLog::getMsg() {
  //TODO: this
  static SLogEntry entry;
  return entry;
}

unsigned int CDeviceLog::getMsgNumbers() {
    // TODO: this
    return 0;
}

