/*******************************************************************************
 * Copyright (c) 2007 4DIAC - consortium.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     <date>: <author>, <author email> - changes
 *******************************************************************************/
#include "txtimeha.h"
#include "../../core/devexec.h"


const TINT32 CTXTimerHandler::csm_nTicksPerSecond = 1000; //TODO check how often we like to be called and get information on how many threadx ticks we get per millisecond

void CTimerHandler::createTimerHandler(void){
  if(0 == sm_poFORTETimer) 
    sm_poFORTETimer = new CTXTimerHandler();
}

CTXTimerHandler::CTXTimerHandler(){
  // register at the device Execution
  m_nExtEvHandID = sm_poDeviceExecution->registerExternalEventHandler(this);
  
// setup the handler for recieving the timer calls  
  UINT status = tx_timer_create(&m_stTimer, "FORTE timer", &timerHandlerFunc, 0, 1, 1, TX_NO_ACTIVATE); 
  if (status == TX_SUCCESS)
    DEVLOG_DEBUG(cg_nID_CTimmerHandler, 0x01, "Timer created\n");
  else
    DEVLOG_DEBUG(cg_nID_CTimmerHandler, 0x01, "Error creating timer\n");
  
  //TODO handle retval
}

CTXTimerHandler::~CTXTimerHandler(){
  disableHandler();
  tx_timer_delete(&m_stTimer);
}

void CTXTimerHandler::enableHandler(void){
  UINT status = tx_timer_activate(&m_stTimer);
  if (status == TX_SUCCESS)
    DEVLOG_DEBUG(cg_nID_CTimmerHandler, 0x02, "Timer activated\n");
  else
    DEVLOG_DEBUG(cg_nID_CTimmerHandler, 0x02, "Error activating timer\n");
  
  //TODO handle retval
}

void CTXTimerHandler::disableHandler(void){
  tx_timer_deactivate(&m_stTimer);
  //TODO handle retval
}

void CTXTimerHandler::setPriority(int pa_nPriority){
}

int CTXTimerHandler::getPriority(void){
  return 0;
}
