/*******************************************************************************
 * Copyright (c) 2007 4DIAC - consortium.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     <date>: <author>, <author email> - changes
 *******************************************************************************/
#include <string.h>
#include "../../forte.h"
#include "../../fblib/ita/RMT_DEV.h"

/*!\brief Creates the Device-Object
 * \param sConn A string containing IP and Port like <IP>:<Port>
 */
void createDev(string sConn) {
	RMT_DEV dev;
	dev.setMGR_ID(sConn);
	forteMain(dev);
	dev.MGR.getResourceEventExecution()->join();
}

/*!\brief Lists the help for FORTE
 * 
 */
void listHelp() {
	printf("\nUsage of FORTE:\n");
	printf("   -h\t lists this help.\n");
	printf("\n");
	printf("   -c\t sets the destination for the connection.\n");
	printf("     \t Usage: forte -c <IP>:<Port>");
	printf("\n");
}

int main(int argc, char *arg[]) {  
	if (argc <= 1) { //! Default Value (localhost:61499)
		createDev("localhost:61499");
	}
	else {
		if (strcmp("-c", arg[1]) == 0) { //! sets the destination for the connection
			createDev(arg[2]);
		}
		else { //! Lists the help for FORTE
			listHelp();
		}
	}
	return 0; 
}
