/*******************************************************************************
 * Copyright (c) 2007 4DIAC - consortium.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     <date>: <author>, <author email> - changes
 *******************************************************************************/
#include "pctimeha.h"
#include "../../core/devexec.h"
#include <time.h>

const TINT32 CPCTimerHandler::csm_nTicksPerSecond = 1000;

void CTimerHandler::createTimerHandler(void){
  if(0 == sm_poFORTETimer) 
    sm_poFORTETimer = new CPCTimerHandler();
}

CPCTimerHandler::CPCTimerHandler(){
  // register at the device Execution
  m_nExtEvHandID = sm_poDeviceExecution->registerExternalEventHandler(this);
}

CPCTimerHandler::~CPCTimerHandler(){
  disableHandler();
}

bool CPCTimerHandler::run(){
  struct timespec stReq;
  stReq.tv_sec = 0;
  stReq.tv_nsec = 1000000 / (csm_nTicksPerSecond / 1000);
  
  while(m_bAlive){
    nanosleep(&stReq, NULL);
    nextTick(); 
  } 
  return true;
}

void CPCTimerHandler::enableHandler(void){
  start();
}

void CPCTimerHandler::disableHandler(void){
  end(); 
}

void CPCTimerHandler::setPriority(int ){
  //TODO think on hwo to handle this.
}

int CPCTimerHandler::getPriority(void){
  //TODO think on hwo to handle this.
  return 1;
}
