/*******************************************************************************
 * Copyright (c) 2007 4DIAC - consortium.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     <date>: <author>, <author email> - changes
 *      2008-04-24: ih, hegny@acin.tuwien.ac.at - added adapter support - initial version
 *******************************************************************************/
#include <string.h>
#include "adapter.h"
#include "adapterconn.h"

CAdapter::CAdapter(CStringDictionary::TStringId pa_nAppl, CResource *pa_poSrcRes,
    const SFBInterfaceSpec *pa_pstInterfaceSpecSocket,
    TEventConnectionPtr *pa_apoEOConns, TDataConnectionPtr *pa_apoDIConns,
    TIEC_ANYPtr *pa_apoDIs, TDataConnectionPtr *pa_apoDOConns,
    TIEC_ANYPtr *pa_apoDOs, const SFBInterfaceSpec *pa_pstInterfaceSpecPlug,
    TEventConnectionPtr *pa_apoEIConns, const char *pa_acAdapterInstanceName,
     bool pa_bIsPlug) :
  CFunctionBlock(pa_nAppl, pa_poSrcRes, 
      (pa_bIsPlug) ? pa_pstInterfaceSpecPlug : pa_pstInterfaceSpecSocket , 
      (pa_bIsPlug) ? pa_apoEIConns : pa_apoEOConns,
      (pa_bIsPlug) ? pa_apoDOConns : pa_apoDIConns,
      pa_apoDIs,
      (pa_bIsPlug) ? pa_apoDIConns : pa_apoDOConns,
      pa_apoDOs) {
  m_bIsPlug = pa_bIsPlug;
  m_apoLocalDIs = m_apoDIs;
  m_poPeer = 0;
  m_poAdapterConn = 0;
  setInstanceNameId(CStringDictionary::getInstance().insert(pa_acAdapterInstanceName));
}

CAdapter::~CAdapter() {
  if (m_bIsPlug) {
    if (m_poAdapterConn!=0) m_poAdapterConn->setPlug(0);
  }
  else {
    if (m_poAdapterConn!=0) m_poAdapterConn->setSocket(0);
  }
}

bool CAdapter::connect(CAdapter *pa_poPeer, CAdapterConnection *pa_poAdConn) {
  if (m_poPeer==0) {
    m_poPeer=pa_poPeer;
    m_apoDIs = pa_poPeer->m_apoDOs; //TODO: change is adapters of subtypes may be connected
    m_poAdapterConn=pa_poAdConn;
    return true;
  } else {
    return false; //already connected
  }
}

bool CAdapter::disconnect(CAdapterConnection *pa_poAdConn) {
  if ((pa_poAdConn!=0) && (pa_poAdConn != m_poAdapterConn))
    return false; //connection requesting disconnect is not equal to established connection
  m_poPeer=0;
  m_apoDIs = m_apoLocalDIs;
  return true;
}

