/*******************************************************************************
 * Copyright (c) 2007 4DIAC - consortium.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     <date>: <author>, <author email> - changes
 *   20080709: AZ, alil@ausers.sourceforge.net - Implemented access mechanisms to ecc state.
 *             This allows to read and write the current ecc state of a basic FB.
 *******************************************************************************/
#include <string.h>
#include "basicfb.h"

CBasicFB::CBasicFB(CStringDictionary::TStringId pa_nAppl, CResource *pa_poSrcRes,
           const SFBInterfaceSpec *pa_pstInterfaceSpec,
                 TEventConnectionPtr *pa_apoEOConns,
                 TDataConnectionPtr *pa_apoDIConns,
                 TIEC_ANYPtr *pa_apoDIs,
                 TDataConnectionPtr *pa_apoDOConns,
                 TIEC_ANYPtr *pa_apoDOs,
                 TUINT8 pa_nNumInternals,
           const TFBNameListEntry *pa_acInternalNames,
                 TIEC_ANYPtr *pa_apoInternals):
    CFunctionBlock(pa_nAppl, pa_poSrcRes, pa_pstInterfaceSpec, pa_apoEOConns,
                   pa_apoDIConns, pa_apoDIs, pa_apoDOConns, pa_apoDOs){

  m_nNumInternals = pa_nNumInternals,
  m_acInternalNames = pa_acInternalNames,
  m_apoInternals = pa_apoInternals;
  m_nECCState = 0;
}

CBasicFB::~CBasicFB(){
}

CIEC_ANY *CBasicFB::getInternalVar(const char *pa_acInternalName){
  for(int i = 0; i < m_nNumInternals; ++i)
    if(!strncmp(pa_acInternalName, m_acInternalNames[i], cg_nIdentifierLength))
      return m_apoInternals[i];
  return 0;
}

CIEC_ANY *CBasicFB::getVar(char *pa_acVarName){
  CIEC_ANY *poRetVal = CFunctionBlock::getVar(pa_acVarName);
  if(0 == poRetVal){
    poRetVal = getInternalVar(pa_acVarName);
    if( 0 == poRetVal){
      if(!strcmp("$ECC", pa_acVarName)){
        poRetVal =  &m_nECCState;
      }
    }
  }
  return poRetVal;
}

