/*******************************************************************************
 * Copyright (c) 2007 4DIAC - consortium.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     <date>: <author>, <author email> - changes
 *******************************************************************************/
#include <string.h>
#include "conn.h"
#include "stringdict.h"

using namespace std;

EMGMResponse CConnection::connect(TConnectionID pa_nDstId, CFunctionBlock &pa_roSrcFB, CFunctionBlock &pa_roDstFB, const char *pa_sDstInput){
  EMGMResponse retval = e_INVALID_STATE;
  if(!dstExists(pa_nDstId)){ // check if there is up to now no such fan out with this destination
    m_lstDestinationIds.insert(std::set<TConnectionID>::value_type(pa_nDstId));
    retval = e_RDY;
  }
  return retval;
}

EMGMResponse CConnection::disconnect(TConnectionID pa_nDstId, CFunctionBlock &pa_roSrcFB, CFunctionBlock &pa_roDstFB, const char *pa_sDstInput){
  EMGMResponse retval = e_NO_SUCH_OBJECT;
  
  std::set<TConnectionID>::iterator itToDel(m_lstDestinationIds.find(pa_nDstId));
  if(itToDel != m_lstDestinationIds.end()){
    m_lstDestinationIds.erase(itToDel);
    retval = e_RDY;
  }
  return retval;
}
