/*******************************************************************************
 * Copyright (c) 2007 4DIAC - consortium.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     <date>: <author>, <author email> - changes
 *******************************************************************************/
#ifndef _ANY_ELE_H_
#define _ANY_ELE_H_

#include "any.h"

/*!\ingroup COREDTS IIEC_ANY_ELEMENTARY represents the elementary data types according to
 *  IEC 61131.
 *  @author tstras & imuell
 *  @version 20081201/mmm - added fromString, toString
 *  @version 20081112/mmm - Constructor added, Name changed from IIEC_ANY_ELEMENTARY to CIEC_ANY_ELEMENTARY
 *  @version 20060719/tstras - default destructor added
 *  @version 20051205/tstras - Name changed from IIEC_PrimDt to IIEC_ANY_ELEMENTARY
 *  @version 20051017/tstras & imuell - Initial version
 */
class CIEC_ANY_ELEMENTARY : public CIEC_ANY {
public:
	CIEC_ANY_ELEMENTARY(EDataTypeID pa_eDataTypeID) : CIEC_ANY(pa_eDataTypeID) {

	}
  virtual ~CIEC_ANY_ELEMENTARY() {};
  virtual bool toString(string &pa_rsValue);
  virtual bool fromString(const string &pa_rsValue);

};

#endif /*_MANY_ELE_H_*/
