/*******************************************************************************
 * Copyright (c) 2007 4DIAC - consortium.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     <date>: <author>, <author email> - changes
 *******************************************************************************/
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include "forte_dat.h"
#include "../../arch/timerha.h"

DEFINE_FIRMWARE_DATATYPE(DATE_AND_TIME)

bool CIEC_DATE_AND_TIME::fromString(const string& pa_rsValue) {
	// 2007-12-21-15:00:00.000

	const char *p=0;
	struct tm tm;
	int msec = 0;

	memset(&tm, 0, sizeof(tm));

	p = pa_rsValue.c_str();
	if (p) {
		tm.tm_year = atoi(p)-1900;
		p = strchr(p, '-');
	}
	if (p) {
		tm.tm_mon = atoi(p+1)-1;
		p = strchr(p+1, '-');
	}
	if (p) {
		tm.tm_mday = atoi(p+1);
		p = strchr(p+1, '-');
	}
	if (p) {
		tm.tm_hour = atoi(p+1);
		p = strchr(p+1, ':');
	}
	if (p) {
		tm.tm_min = atoi(p+1);
		p = strchr(p+1, ':');
	}
	if (p) {
		tm.tm_sec = atoi(p+1);
		p = strchr(p+1, '.');
	}
	if (p) {
		msec = atoi(p+1);
	}

#if ! defined(WINCE)
	setTUINT64(mktime(&tm)*1000ULL + msec);
#else
	setTUINT64(wceex_mktime(&tm)*1000ULL + msec);
#endif

  return true;
}

bool CIEC_DATE_AND_TIME::toString(string& pa_rsValue) {
  char buffer[33];
  TUINT64 nToStringBuffer = getTUINT64();
	time_t t = nToStringBuffer / 1000;
#if ! defined(WINCE)
	struct tm *ptm = localtime(&t);
#else
	struct tm *ptm = wceex_localtime(&t);
#endif
	snprintf(buffer, 33, "%04d-%02d-%02d-%02d:%02d:%02d.%03d", 1900+ptm->tm_year, ptm->tm_mon+1, ptm->tm_mday, ptm->tm_hour, ptm->tm_min, ptm->tm_sec, (int) (nToStringBuffer % 1000));

  pa_rsValue.assign(buffer);
  return true;
}
