/*******************************************************************************
 * Copyright (c) 2007 4DIAC - consortium.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     <date>: <author>, <author email> - changes
 *******************************************************************************/
#include <stdlib.h>
#include <math.h>
#include <time.h>
#include <string.h>
#include "forte_date.h"
#include "../../arch/timerha.h"
#if defined(WINCE)
#include <wce_time.h>
#endif

DEFINE_FIRMWARE_DATATYPE(DATE)

bool CIEC_DATE::fromString(const string& pa_rsValue) {
	// 2007-12-21

	const char *p=0;
	struct tm tm;

	memset(&tm, 0, sizeof(tm));

	p = pa_rsValue.c_str();
	if (p) {
		tm.tm_year = atoi(p)-1900;
		p = strchr(p, '-');
	}
	if (p) {
		tm.tm_mon = atoi(p+1)-1;
		p = strchr(p+1, '-');
	}
	if (p) {
		tm.tm_mday = atoi(p+1);
		p = strchr(p+1, '-');
	}


#if ! defined(WINCE)
	setTUINT64(mktime(&tm)*1000ULL);
#else
	setTUINT64(wceex_mktime(&tm)*1000ULL);
#endif
	// TODO: timezone handling

  return true;
}

bool CIEC_DATE::toString(string& pa_rsValue) {
  char buffer[33];
	time_t t = getTUINT64() / 1000;

#if ! defined(WINCE)
	struct tm *ptm = localtime(&t);
#else
	struct tm *ptm = wceex_localtime(&t);
#endif
	snprintf(buffer, 33, "%04d-%02d-%02d", 1900+ptm->tm_year, ptm->tm_mon+1, ptm->tm_mday);

	// TODO: timezone handlng

  pa_rsValue.assign(buffer);
  return true;
}
