/*******************************************************************************
 * Copyright (c) 2007 4DIAC - consortium.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     <date>: <author>, <author email> - changes
 *******************************************************************************/
#include <math.h>
#include "forte_lreal.h"

DEFINE_FIRMWARE_DATATYPE(LREAL)

bool CIEC_LREAL::fromString(const std::string& pa_rsValue) {
  char *pcEnd;
  double realval = 0.0;
  const TDFLOAT TDFLOAT_min = 1.7e-308; // lower precision boundary
  const TDFLOAT TDFLOAT_max = 1.7e308;  // upper precision boundary

  realval = strtod(pa_rsValue.c_str(),&pcEnd);

  if(((fabs(realval) < TDFLOAT_min) && (realval !=0)) ||
     ((fabs(realval) > TDFLOAT_max) && (realval !=0)) ||
     (*pcEnd != '\0'))
    return false;

  setTDFLOAT((TDFLOAT)realval);
  return true;
}

bool CIEC_LREAL::toString(std::string& pa_rsValue) {
  char cbuffer[66];
  int realval = snprintf(cbuffer, 66, "%g", getTDFLOAT());

  if(realval < 0)
    return false;
  pa_rsValue.assign(cbuffer);
  return true;
}
