/*******************************************************************************
 * Copyright (c) 2007 4DIAC - consortium.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     <date>: <author>, <author email> - changes
 *******************************************************************************/
#include <math.h>
#include "forte_real.h"

DEFINE_FIRMWARE_DATATYPE(REAL)

bool CIEC_REAL::fromString(const std::string& pa_rsValue) {
  char *pcEnd;
  TFLOAT realval = 0.0;
  const TFLOAT TFLOAT_min = 3.4e-38; // lower precision boundary
  const TFLOAT TFLOAT_max = 3.4e38;  // upper precision boundary

  realval = strtof(pa_rsValue.c_str(),&pcEnd);

  if(((fabs(realval) < TFLOAT_min) && (realval !=0)) ||
     ((fabs(realval) > TFLOAT_max) && (realval !=0)) ||
     (*pcEnd != '\0'))
    return false;

  setTFLOAT((TFLOAT)realval);
  return true;
}

bool CIEC_REAL::toString(std::string& pa_rsValue) {
  char cbuffer[66];
  int realval = snprintf(cbuffer, 66, "%g",getTFLOAT());

  if(realval < 0)
    return false;
  pa_rsValue.assign(cbuffer);
  return true;
}
