/*******************************************************************************
 * Copyright (c) 2007 4DIAC - consortium.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     <date>: <author>, <author email> - changes
 *******************************************************************************/
#include <stdlib.h>
#include <math.h>
#include "forte_time.h"
#include "../../arch/timerha.h"

DEFINE_FIRMWARE_DATATYPE(TIME)

bool CIEC_TIME::fromString(const string& pa_rsValue) {
  long intval = 0;
  long runvar = 0;
  long timemax = 2147483647;

  if(((pa_rsValue[0] == 'T')||(pa_rsValue[0] == 't')) && (pa_rsValue[1] == '#')){ // the string has to start with T#
    runvar = (pa_rsValue.find("#"));
    // identification of days within the IEC-Time-String
    if ((pa_rsValue.find("d")) != (pa_rsValue.npos)){
      intval = 86400000*(strtol((pa_rsValue.substr((runvar+1),
        (pa_rsValue.find("d")-(runvar+1)))).c_str(),
          NULL,
            10));//days
      runvar = pa_rsValue.find("d");
      if ((timemax - intval) < 0) return false;
    }
    // identification of hours within the IEC-Time-String
    if ((pa_rsValue.find("h")) != (pa_rsValue.npos)){
      intval = intval + 3600000*(strtol((pa_rsValue.substr((runvar+1),
        (pa_rsValue.find("h")-(runvar+1)))).c_str(),
          NULL,
            10));//hours
      runvar = pa_rsValue.find("h");
      if ((timemax - intval) < 0) return false;
    }
    // identification of minutes within the IEC-Time-String
    if (((pa_rsValue.find("m")) != (pa_rsValue.npos))&&((pa_rsValue.find("s"))>(pa_rsValue.find("m"))+1)){
      intval = intval + 60000*(strtol((pa_rsValue.substr((runvar+1),
        (pa_rsValue.find("m")-(runvar+1)))).c_str(),
          NULL,
            10));//minutes
      runvar = pa_rsValue.find("m");
      if ((timemax - intval) < 0) return false;
    }
    // identification of seconds within the IEC-Time-String
    if (((pa_rsValue.find("s")) != (pa_rsValue.npos))&&((pa_rsValue.find("s"))>(pa_rsValue.find("m"))+1)){
      intval = intval + 1000*(strtol((pa_rsValue.substr((runvar+1),
        (pa_rsValue.find("s")-(runvar+1)))).c_str(),
          NULL,
            10));//seconds
      runvar = pa_rsValue.find("s");
      if ((timemax - intval) < 0) return false;
    }
    // identification of milliseconds within the IEC-Time-String
    if ((pa_rsValue.find("ms")) != (pa_rsValue.npos)){
      intval = intval + strtol((pa_rsValue.substr((runvar+1),
        (pa_rsValue.find("ms")-(runvar+1)))).c_str(),
          NULL,
            10);//milliseconds
      runvar = pa_rsValue.find("ms");
      if ((timemax - intval) < 0) return false;
    }

  if((pa_rsValue.find("-")) != (pa_rsValue.npos))
    intval = intval * (-1);
  }
  else{
    atol(pa_rsValue.c_str());
  }

  setTINT32((TINT32)intval * CTimerHandler::sm_poFORTETimer->getTicksPerSecond() / 1000);
  return true;
}

bool CIEC_TIME::toString(string& pa_rsValue) {
  char buffer[33];
  TINT32 timeInMilliSeconds = getTINT32() * 1000 / CTimerHandler::sm_poFORTETimer->getTicksPerSecond();

  // XXX stano
#ifdef _WIN32
  sprintf(buffer, "T#%ldms",timeInMilliSeconds);
#else
  snprintf(buffer, 33, "T#%ldms",timeInMilliSeconds);
#endif
  pa_rsValue.assign(buffer);
  return true;
}
