/*******************************************************************************
 * Copyright (c) 2007 4DIAC - consortium.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     <date>: <author>, <author email> - changes
 *******************************************************************************/
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include "forte_tod.h"
#include "../../arch/timerha.h"


DEFINE_FIRMWARE_DATATYPE(TIME_OF_DAY)

bool CIEC_TIME_OF_DAY::fromString(const string& pa_rsValue) {
	// 15:00:00.000

	const char *p=0;
	struct tm tm;
	int msec = 0;

	memset(&tm, 0, sizeof(tm));

	p = pa_rsValue.c_str();
	if (p) {
		tm.tm_hour = atoi(p);
		p = strchr(p+1, ':');
	}
	if (p) {
		tm.tm_min = atoi(p+1);
		p = strchr(p+1, ':');
	}
	if (p) {
		tm.tm_sec = atoi(p+1);
		p = strchr(p+1, '.');
	}
	if (p) {
		msec = atoi(p+1);
	}

	setTUINT64((tm.tm_hour*3600+tm.tm_min*60+tm.tm_sec)*1000ULL + msec);

  return true;
}

bool CIEC_TIME_OF_DAY::toString(string& pa_rsValue) {
  char buffer[33];
  TUINT64 ntoStingBuffer = getTUINT64();
	time_t t = ntoStingBuffer / 1000;

	snprintf(buffer, 33, "%02d:%02d:%02d.%03d",
		(int) (t / 3600),
		(int) ((t % 3600) / 60),
		(int) (t % 60),
		(int) (ntoStingBuffer % 1000));

  pa_rsValue.assign(buffer);
  return true;
}

