/*******************************************************************************
 * Copyright (c) 2007 4DIAC - consortium.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     <date>: <author>, <author email> - changes
 *******************************************************************************/
#include <string.h>
#include "device.h"
#include "resource.h"
#include "if2indco.h"

CFunctionBlock *CDevice::createFBObject(CStringDictionary::TStringId pa_nInstanceNameId, CStringDictionary::TStringId pa_nResTypeId, CStringDictionary::TStringId ){
  return m_roTypeLib.createResource(pa_nInstanceNameId, pa_nResTypeId, *this);
}

EMGMResponse CDevice::executeMGMCommand(SManagementCMD &pa_oCommand){
  EMGMResponse retval = e_INVALID_DST;
  
  if(CStringDictionary::scm_nInvalidStringId == pa_oCommand.m_nDestination){ 
    retval = C61499ObjectHandler::executeMGMCommand(pa_oCommand);
  }
  else{
    //FIXME if other destinations than resources need to be supported the name of the resource has to be extracted here 
    CResource *res = (CResource *)getFB(pa_oCommand.m_nDestination);
    if(0 != res){
      pa_oCommand.m_nDestination = CStringDictionary::scm_nInvalidStringId;
      retval = res->executeMGMCommand(pa_oCommand);
    }  
  }
  return retval;  
}


