/*******************************************************************************
 * Copyright (c) 2007 4DIAC - consortium.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     <date>: <author>, <author email> - changes
 *******************************************************************************/ 
#ifndef _ESFB_H_
#define _ESFB_H_

#include "sifb.h"

/*!\ingroup CORE\brief Base-Class for all event sources.
 * 
 * @author AZ
 * @version 20060207/AZ - Removed number of EOs in CFunctionBlock-Constructor
 * @version 20060206/AZ - Changed event connection handling 
 * @version 20051022/AZ - First version as basis for interface description
 */
class CEventSourceFB : public CServiceInterfaceFB{
private:
 
/* \brief the event chain executor used by this ES. 
 */
  CEventChainExecutionThread *m_poEventChainExecutor;
protected:
   SEventEntry m_stEventSourceEventEntry; //! the event entry to start the event chain
public:
  CEventSourceFB(CStringDictionary::TStringId pa_nAppl, CResource *pa_poSrcRes,   
           const SFBInterfaceSpec *pa_pstInterfaceSpec,
                 TEventConnectionPtr *pa_apoEOConns, 
                 TDataConnectionPtr *pa_apoDIConns,
                 TIEC_ANYPtr *pa_apoDIs,  
                 TDataConnectionPtr *pa_apoDOConns,  
                 TIEC_ANYPtr *pa_apoDOs) : 
    CServiceInterfaceFB(pa_nAppl, pa_poSrcRes, 
            pa_pstInterfaceSpec, pa_apoEOConns, pa_apoDIConns, pa_apoDIs, pa_apoDOConns, pa_apoDOs){
    m_poEventChainExecutor = 0;  
    m_stEventSourceEventEntry.m_nEIID = cg_nExternalEventID;
  }
  virtual ~CEventSourceFB() {}; 
  void setEventChainExecutor(CEventChainExecutionThread *pa_poEventChainExecutor) { m_poEventChainExecutor = pa_poEventChainExecutor; };
  CEventChainExecutionThread * getEventChainExecutor(void) { return m_poEventChainExecutor; };
  
  SEventEntry *getEventSourceEventEntry(void) { return &m_stEventSourceEventEntry; };
};

#endif /*_ESFB_H_*/
