/* Copyright (c) 2007 4DIAC - consortium.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     <date>: <author>, <author email> - changes
 *    20071029: az, alil@users.sourceforge.net - changed constructor of interface data connections
 *******************************************************************************/
#include "if2indco.h"

EMGMResponse CInterface2InternalDataConnection::connect(TConnectionID pa_nDstId, CFunctionBlock &pa_roSrcFB, CFunctionBlock &pa_roDstFB, const char *pa_sDstInput) {
  EMGMResponse retval = e_NO_SUCH_OBJECT;
  unsigned int nDIID = pa_roDstFB.getDIID(pa_sDstInput);

  if(nDIID == cg_nInvalidDataInputID) {  //gugr: check if DstFB has data input, check if SrcFB has data output done during creation of connection
    return retval;
  }

  CIEC_ANY *poDstInput = pa_roDstFB.getDataInput(nDIID);

  CIEC_ANY::EDataTypeID dstFBDTID = CIEC_ANY::e_ANY;
  if (poDstInput != 0) {	//Datapointer equals 0 means Datatype is e_ANY
	  dstFBDTID = poDstInput->getDataTypeID();  //gugr: get the datatype of local FB data input variable object
  }

  if(e_RDY == (retval = CConnection::connect(pa_nDstId, pa_roSrcFB, pa_roDstFB, pa_sDstInput))){
    if(m_poValue->getDataTypeID() != dstFBDTID){
      if(dstFBDTID == CIEC_ANY::e_ANY){
        poDstInput=(m_poValue->clone());
      }
      else{
        disconnect(pa_nDstId, pa_roSrcFB, pa_roDstFB, pa_sDstInput);
        retval = e_INVALID_OBJECT;
      }
    }
    if(retval == e_RDY){
      pa_roDstFB.connectDI(nDIID, this);
      m_lstDstFBPtr.push_back(&pa_roDstFB);
    }
  }
  return retval;
}

//TODO: Alil check if needed, Currently no necessity is seen for this functions
// EMGMResponse CInterface2InternalDataConnection::disconnect(TUINT32 pa_nDstId, CFunctionBlock &pa_roSrcFB, CFunctionBlock &pa_roDstFB, const char *pa_sDstInput) {
//   EMGMResponse  retval = CDataConnection::disconnect(pa_nDstId, pa_roSrcFB, pa_roDstFB, pa_sDstInput);
//   return retval;
// }

void CInterface2InternalDataConnection::cloneInputInterfaceValue(void){
  set<TConnectionID>::iterator runnerDst(m_lstDestinationIds.begin());
  for(list<CFunctionBlock*>::iterator runnerFB(m_lstDstFBPtr.begin());
      runnerFB != m_lstDstFBPtr.end(); ++runnerFB){   //run through inner destination FB array
	  unsigned int nDIID = (*runnerFB)->getDIID(CStringDictionary::getInstance().get(((CStringDictionary::TStringId)((*runnerDst)&0xFFFFFFFF))));
    (*runnerFB)->connectDI(nDIID, this);
    ++runnerDst;
  }
}
