/*******************************************************************************
 * Copyright (c) 2007 4DIAC - consortium.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     <date>: <author>, <author email> - changes
 *    20071029: az, alil@users.sourceforge.net - changed constructor of interface data connections
 *******************************************************************************/
#include "in2ifdco.h"

EMGMResponse CInternal2InterfaceDataConnection::connectInterfaceData(CFunctionBlock &pa_roSrcFB, CFunctionBlock &pa_roDstFB, const char *pa_sDstInput){
  EMGMResponse retval = e_NO_SUCH_OBJECT;
  TConnectionID nDestId = CConnection::genConPortIdSingle(pa_sDstInput);
  if(e_RDY == (retval = CConnection::connect(nDestId, pa_roSrcFB, pa_roDstFB, pa_sDstInput))){
    const char *acOutName = getOutputName();
    const unsigned int nDOID = pa_roSrcFB.getDOID(acOutName);
    CIEC_ANY *poSrcOutput = pa_roSrcFB.getDataOutput(nDOID);

    CIEC_ANY::EDataTypeID srcFBDTID = CIEC_ANY::e_ANY;
    if (poSrcOutput != 0) {
    	srcFBDTID = poSrcOutput->getDataTypeID();
    }

    if(m_poValue->getDataTypeID() != srcFBDTID){
      if(srcFBDTID == CIEC_ANY::e_ANY){
        poSrcOutput=(m_poValue->clone());
      }
      else{
        disconnect(nDestId, pa_roSrcFB, pa_roDstFB, pa_sDstInput);
        retval = e_INVALID_OBJECT;
      }
    }
    if(retval == e_RDY){
      pa_roSrcFB.connectDO(nDOID, this);
      m_poSrcFBPtr = &pa_roSrcFB;
    }
  }
  return retval;
}


//TODO: Alil check if needed, Currently no necesity is seen for this functions
// EMGMResponse CInternal2InterfaceDataConnection::disconnect(TUINT32 pa_nDstId, CFunctionBlock &pa_roSrcFB, CFunctionBlock &pa_roDstFB, const char *pa_sDstInput) {
//   EMGMResponse  retval = CConnection::disconnect(pa_nDstId, pa_roSrcFB, pa_roDstFB, pa_sDstInput);
//   return retval;
// }

void CInternal2InterfaceDataConnection::cloneOutputInterfaceValue(void){
  const char *acOutName = getOutputName();
  const unsigned int nDOID = m_poSrcFBPtr->getDOID(acOutName);
  CIEC_ANY *poSrcOutput = m_poSrcFBPtr->getDataOutput(nDOID);
  if(poSrcOutput->getDataTypeID() == CIEC_ANY::e_ANY){
    m_poSrcFBPtr->connectDO(nDOID, this);
  }
}
