/*******************************************************************************
 * Copyright (c) 2007 4DIAC - consortium.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     <date>: <author>, <author email> - changes
 *    20071029: az, alil@users.sourceforge.net - changed constructor of interface data connections
 *******************************************************************************/
#ifndef _IN2IFDCO_H_
#define _IN2IFDCO_H_

#include "./datatypes/any.h"
#include "dataconn.h"
#include "funcbloc.h"

/*! \ingroup CORE\brief class for handling a internal to interface data connection.
 *  @author GG
 *  @version 20081121/mmm - changed due to elimination of ANY_FACADE
 *  @version 20071029/az - Changed constructor of interface data connections
 *  @version 20060718/gugr - Initial version to handle data connections from internal FBs to CFB interface
 */
class CInternal2InterfaceDataConnection : public CDataConnection {
  private:
 /*! \brief Class member variable
 */
    CFunctionBlock *m_poSrcFBPtr;

  protected:
  public:
    CInternal2InterfaceDataConnection(const char *pa_acFBName, const char *pa_acOutputName, CIEC_ANY *pa_poValue) : CDataConnection(CConnection::genConPortId(pa_acFBName, pa_acOutputName)) {
      m_poValue = pa_poValue;
      m_poSrcFBPtr = 0;
    };
    virtual ~CInternal2InterfaceDataConnection(){
      m_poValue = 0; // in interface data connections we are not allowed to delete the m_poValue
    };

    EMGMResponse connectInterfaceData(CFunctionBlock &pa_roSrcFB, CFunctionBlock &pa_roDstFB, const char *pa_sDstInput);


/*! \brief Clones interface data value (CFB data input) to internal FB data input.
 *
 */
    void cloneOutputInterfaceValue(void);
};

typedef CInternal2InterfaceDataConnection *TCInternal2InterfaceDataConnectionPtr;

#endif /*IN2IFDCO_H_*/
