/*******************************************************************************
 * Copyright (c) 2007 4DIAC - consortium.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     <date>: <author>, <author email> - changes
 *******************************************************************************/
#include "in2ifeco.h"
#include "funcbloc.h"

void CInternal2InterfaceEventConnection::triggerEvent(CEventChainExecutionThread &pa_poExecEnv){
  if(0 != m_stInterfaceConn.m_poFB){
    m_stInterfaceConn.m_poFB->m_poInvokingExecEnv = &pa_poExecEnv;
    m_stInterfaceConn.m_poFB->sendOutputEvent( m_stInterfaceConn.m_nEIID);
  }  
  CEventConnection::triggerEvent(pa_poExecEnv);
}

void CInternal2InterfaceEventConnection::connectInterfaceEvent(CFunctionBlock *pa_poFB, TEventID pa_nEIID){
  m_stInterfaceConn.m_poFB = pa_poFB;
	if (m_stInterfaceConn.m_nEIID != cg_nInvalidEventID && m_stInterfaceConn.m_nEIID != pa_nEIID) {
		DEVLOG_ERROR_2(cg_nID_CFunctionBlock, 0x03, "%s: cannot connect output event of an internal FB to more interface output events, use E_SPLIT\n", CStringDictionary::getInstance().get(pa_poFB->getFBTypeId()));
	}
  m_stInterfaceConn.m_nEIID = pa_nEIID; 
}


