/*******************************************************************************
 * Copyright (c) 2007 4DIAC - consortium.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     <date>: <author>, <author email> - changes
 *******************************************************************************/
#ifndef _IN2IFECO_H_
#define _IN2IFECO_H_

#include "eventconn.h"

/** \ingroup CORE \brief Event connetion from an outer interface to internal elements.
 * 
 * Will be used in devices, resources, and composite function blocks.
	@author Alois Zoitl <zoitl@acin.tuwien.ac.at>
*/
class CInternal2InterfaceEventConnection : public CEventConnection{
  private:
    SEventEntry m_stInterfaceConn;
  protected:
  public:
    CInternal2InterfaceEventConnection(const char *pa_acFBName, const char *pa_acOutputName) : CEventConnection(CConnection::genConPortId(pa_acFBName, pa_acOutputName)){
      m_stInterfaceConn.m_poFB = 0;
      m_stInterfaceConn.m_nEIID = cg_nInvalidEventID;
    };
    virtual ~CInternal2InterfaceEventConnection(){};
    
    virtual void triggerEvent(CEventChainExecutionThread &pa_poExecEnv);
    
    void connectInterfaceEvent(CFunctionBlock *pa_poFB, TEventID pa_nEIID);
};

#endif
