/*******************************************************************************
 * Copyright (c) 2007 4DIAC - consortium.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     <date>: <author>, <author email> - changes
 *******************************************************************************/
#include "resource.h"

EMGMResponse CResource::killManagedObject(void) {
	m_oResourceEventExecution.clear();
  EMGMResponse retval = C61499ObjectHandler::killManagedObject();
  if (retval == e_RDY)
    m_oResourceEventExecution.end();
  return retval;
}

EMGMResponse CResource::stopManagedObject(void) {
	//stop should not clear the event chain as a start of a stopped entity shoul be able to continue
  EMGMResponse retval = C61499ObjectHandler::stopManagedObject();
  if (retval == e_RDY)
    m_oResourceEventExecution.end();
  return retval;
}

EMGMResponse CResource::startManagedObject(void) {
  EMGMResponse retval = C61499ObjectHandler::startManagedObject();

  if (retval == e_RDY) {
    for (int i = 0; i < cm_pstInterfaceSpec->m_nNumDIs; ++i) {
      if (0 != m_apoDIConns[i]) {
        m_apoDIConns[i]->readData(m_apoDIs[i]);
      }
    }
    m_oResourceEventExecution.start(); // allow the executionchainthread to start its execution
  }

  return retval;
}

