/*******************************************************************************
 * Copyright (c) 2007 4DIAC - consortium.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     <date>: <author>, <author email> - changes
 *******************************************************************************/
#ifndef _SIMPLEFB_H_
#define _SIMPLEFB_H_

#include "funcbloc.h"

/*!\ingroup CORE\brief Class for handling firmware simple function blocks according to 
 * Annex D of IEC61499-1.
 * 
 * 
 * @author AZ
 * @version 20070301/AZ - First version
 */
class CSimpleFB : public CFunctionBlock {
private:
protected:
public:
/*!\brief The main constructur for a basic function block.
 */
  CSimpleFB(CStringDictionary::TStringId pa_nAppl, CResource *pa_poSrcRes,
           const SFBInterfaceSpec *pa_pstInterfaceSpec,
                 TEventConnectionPtr *pa_apoEOConns, 
                 TDataConnectionPtr *pa_apoDIConns,
                 TIEC_ANYPtr *pa_apoDIs,  
                 TDataConnectionPtr *pa_apoDOConns,  
                 TIEC_ANYPtr *pa_apoDOs): CFunctionBlock(pa_nAppl, pa_poSrcRes, 
        pa_pstInterfaceSpec, pa_apoEOConns, pa_apoDIConns, pa_apoDIs, pa_apoDOConns, pa_apoDOs){
};
  virtual ~CSimpleFB() {};
};

#endif /*_SIMPLEFB_H_*/
