/*************************************************************************
 *** FORTE Library Element
 ***
 *** Name: BOOL2BOOL
 *** Description: Basic Function Block Type
 *** Version: 
 ***     1.0: 2006-11-14/TS - PROFACTOR GmbH - 
 *************************************************************************/

#include "BOOL2BOOL.h"

DEFINE_FIRMWARE_FB(BOOL2BOOL)

const TFBNameListEntry BOOL2BOOL::scm_acDataInputNames[] = {"IN"};

const TFBNameListEntry BOOL2BOOL::scm_acDataOutputNames[] = {"OUT"};

const TEventID BOOL2BOOL::scm_nEventREQID = 0;
const TINT16 BOOL2BOOL::scm_anEIWithIndexes[] = {0};
const TDataIOID BOOL2BOOL::scm_anEIWith[] = {0, 255};
const TFBNameListEntry BOOL2BOOL::scm_acEventInputNames[] = {"REQ"};

const TEventID BOOL2BOOL::scm_nEventCNFID = 0;
const TDataIOID BOOL2BOOL::scm_anEOWith[] = {0, 255};
const TINT16 BOOL2BOOL::scm_anEOWithIndexes[] = {0, -1};
const TFBNameListEntry BOOL2BOOL::scm_acEventOutputNames[] = {"CNF"};

const SFBInterfaceSpec BOOL2BOOL::scm_stFBInterfaceSpec = {
  1,
  scm_acEventInputNames,
  scm_anEIWith,
  scm_anEIWithIndexes,
  1,
  scm_acEventOutputNames,
  scm_anEOWith,
  scm_anEOWithIndexes,
  1,
  scm_acDataInputNames,
  1,
  scm_acDataOutputNames
};

void BOOL2BOOL::alg_REQ(void){
OUT = IN;
}

const TINT16 BOOL2BOOL::scm_nStateSTART = 0;
const TINT16 BOOL2BOOL::scm_nStateREQ = 1;

void BOOL2BOOL::enterStateSTART(void){
  m_nECCState = scm_nStateSTART;
}

void BOOL2BOOL::enterStateREQ(void){
  m_nECCState = scm_nStateREQ;
  alg_REQ();
  sendOutputEvent( scm_nEventCNFID);
}

bool BOOL2BOOL::executeECCOnce(TEventID pa_nEIID){
  bool bRetVal = true;
  switch(m_nECCState){
    case scm_nStateSTART:
      if(scm_nEventREQID == pa_nEIID)
      	enterStateREQ();
      else
        bRetVal = false; //no transition cleared
      break;
    case scm_nStateREQ:
      if(1)
      	enterStateSTART();
      else
        bRetVal = false; //no transition cleared
      break;
    default:
      DEVLOG_ERROR(cg_nID_CFunctionBlock, 0x01 , "The ECC state is not in the valid range!");
      m_nECCState = 0; //0 is allways the initial state
      break;
  }
  return bRetVal;
}

BOOL2BOOL::BOOL2BOOL(CStringDictionary::TStringId pa_nAppl, CResource *pa_poSrcRes) : 
       CBasicFB(pa_nAppl,
           pa_poSrcRes,
           &scm_stFBInterfaceSpec,
           m_apoEOConns,
           m_apoDIConns,
           m_apoDIs,
           m_apoDOConns,
           m_apoDOs,
            0, 0, 0) {
  m_apoDIs[0] = &IN;
  m_apoDOs[0] = &OUT;
}
 
BOOL2BOOL::~BOOL2BOOL(){
}



