/*************************************************************************
 *** FORTE Library Element
 ***
 *** Name: DINT2DINT
 *** Description: Basic Function Block Type
 *** Version: 
 ***     1.0: 2006-11-14/TS - PROFACTOR GmbH - 
 *************************************************************************/

#include "DINT2DINT.h"

DEFINE_FIRMWARE_FB(DINT2DINT)

const TFBNameListEntry DINT2DINT::scm_acDataInputNames[] = {"IN"};

const TFBNameListEntry DINT2DINT::scm_acDataOutputNames[] = {"OUT"};

const TEventID DINT2DINT::scm_nEventREQID = 0;
const TINT16 DINT2DINT::scm_anEIWithIndexes[] = {0};
const TDataIOID DINT2DINT::scm_anEIWith[] = {0, 255};
const TFBNameListEntry DINT2DINT::scm_acEventInputNames[] = {"REQ"};

const TEventID DINT2DINT::scm_nEventCNFID = 0;
const TDataIOID DINT2DINT::scm_anEOWith[] = {0, 255};
const TINT16 DINT2DINT::scm_anEOWithIndexes[] = {0, -1};
const TFBNameListEntry DINT2DINT::scm_acEventOutputNames[] = {"CNF"};

const SFBInterfaceSpec DINT2DINT::scm_stFBInterfaceSpec = {
  1,
  scm_acEventInputNames,
  scm_anEIWith,
  scm_anEIWithIndexes,
  1,
  scm_acEventOutputNames,
  scm_anEOWith,
  scm_anEOWithIndexes,
  1,
  scm_acDataInputNames,
  1,
  scm_acDataOutputNames
};

void DINT2DINT::alg_REQ(void){
OUT = IN;
}

const TINT16 DINT2DINT::scm_nStateSTART = 0;
const TINT16 DINT2DINT::scm_nStateREQ = 1;

void DINT2DINT::enterStateSTART(void){
  m_nECCState = scm_nStateSTART;
}

void DINT2DINT::enterStateREQ(void){
  m_nECCState = scm_nStateREQ;
  alg_REQ();
  sendOutputEvent( scm_nEventCNFID);
}

bool DINT2DINT::executeECCOnce(TEventID pa_nEIID){
  bool bRetVal = true;
  switch(m_nECCState){
    case scm_nStateSTART:
      if(scm_nEventREQID == pa_nEIID)
      	enterStateREQ();
      else
        bRetVal = false; //no transition cleared
      break;
    case scm_nStateREQ:
      if(1)
      	enterStateSTART();
      else
        bRetVal = false; //no transition cleared
      break;
    default:
      DEVLOG_ERROR(cg_nID_CFunctionBlock, 0x01 , "The ECC state is not in the valid range!");
      m_nECCState = 0; //0 is allways the initial state
      break;
  }
  return bRetVal;
}

DINT2DINT::DINT2DINT(CStringDictionary::TStringId pa_nAppl, CResource *pa_poSrcRes) : 
       CBasicFB(pa_nAppl,
           pa_poSrcRes,
           &scm_stFBInterfaceSpec,
           m_apoEOConns,
           m_apoDIConns,
           m_apoDIs,
           m_apoDOConns,
           m_apoDOs,
            0, 0, 0) {
  m_apoDIs[0] = &IN;
  m_apoDOs[0] = &OUT;
}
 
DINT2DINT::~DINT2DINT(){
}



