/*************************************************************************
 *** FORTE Library Element
 ***
 *** Name: INT2INT
 *** Description: Basic Function Block Type
 *** Version: 
 ***     1.0: 2006-11-14/TS - PROFACTOR GmbH - 
 *************************************************************************/

#ifndef _INT2INT_H_
#define _INT2INT_H_

#include <basicfb.h>
#include <forte_int.h>


class INT2INT: public CBasicFB{
  DECLARE_FIRMWARE_FB(INT2INT)

private:
  static const TFBNameListEntry scm_acDataInputNames[];
  CIEC_INT IN;
  static const TFBNameListEntry scm_acDataOutputNames[];
  CIEC_INT OUT;
  static const TEventID scm_nEventREQID;
  static const TINT16 scm_anEIWithIndexes[];
  static const TDataIOID scm_anEIWith[];
  static const TFBNameListEntry scm_acEventInputNames[];

  static const TEventID scm_nEventCNFID;
  static const TINT16 scm_anEOWithIndexes[];
  static const TDataIOID scm_anEOWith[];
  static const TFBNameListEntry scm_acEventOutputNames[];

  static const SFBInterfaceSpec scm_stFBInterfaceSpec;

  TEventConnectionPtr m_apoEOConns[1];
  TDataConnectionPtr m_apoDIConns[1];
  TIEC_ANYPtr m_apoDIs[1];
  TDataConnectionPtr m_apoDOConns[1];
  TIEC_ANYPtr m_apoDOs[1];
  void alg_REQ(void);
  static const TINT16 scm_nStateSTART;
  static const TINT16 scm_nStateREQ;

  void enterStateSTART(void);
  void enterStateREQ(void);

protected:
  virtual bool executeECCOnce(TEventID pa_nEIID);

public:
  INT2INT(CStringDictionary::TStringId pa_nAppl, CResource *pa_poSrcRes);
  virtual ~INT2INT();

};

#endif //close the ifdef sequence from the beginning of the file

