/*************************************************************************
 *** FORTE Library Element
 ***
 *** Name: UDINT2UDINT
 *** Description: Basic Function Block Type
 *** Version: 
 ***     1.0: 2006-11-14/TS - PROFACTOR GmbH - 
 *************************************************************************/

#ifndef _UDINT2UDINT_H_
#define _UDINT2UDINT_H_

#include <basicfb.h>
#include <forte_udint.h>


class UDINT2UDINT: public CBasicFB{
  DECLARE_FIRMWARE_FB(UDINT2UDINT)

private:
  static const TFBNameListEntry scm_acDataInputNames[];
  CIEC_UDINT IN;
  static const TFBNameListEntry scm_acDataOutputNames[];
  CIEC_UDINT OUT;
  static const TEventID scm_nEventREQID;
  static const TINT16 scm_anEIWithIndexes[];
  static const TDataIOID scm_anEIWith[];
  static const TFBNameListEntry scm_acEventInputNames[];

  static const TEventID scm_nEventCNFID;
  static const TINT16 scm_anEOWithIndexes[];
  static const TDataIOID scm_anEOWith[];
  static const TFBNameListEntry scm_acEventOutputNames[];

  static const SFBInterfaceSpec scm_stFBInterfaceSpec;

  TEventConnectionPtr m_apoEOConns[1];
  TDataConnectionPtr m_apoDIConns[1];
  TIEC_ANYPtr m_apoDIs[1];
  TDataConnectionPtr m_apoDOConns[1];
  TIEC_ANYPtr m_apoDOs[1];
  void alg_REQ(void);
  static const TINT16 scm_nStateSTART;
  static const TINT16 scm_nStateREQ;

  void enterStateSTART(void);
  void enterStateREQ(void);

protected:
  virtual bool executeECCOnce(TEventID pa_nEIID);

public:
  UDINT2UDINT(CStringDictionary::TStringId pa_nAppl, CResource *pa_poSrcRes);
  virtual ~UDINT2UDINT();

};

#endif //close the ifdef sequence from the beginning of the file

