/*************************************************************************
 *** FORTE Library Element
 ***
 *** Name: UINT2UINT
 *** Description: Basic Function Block Type
 *** Version: 
 ***     1.0: 2006-11-14/TS - PROFACTOR GmbH - 
 *************************************************************************/

#include "UINT2UINT.h"

DEFINE_FIRMWARE_FB(UINT2UINT)

const TFBNameListEntry UINT2UINT::scm_acDataInputNames[] = {"IN"};

const TFBNameListEntry UINT2UINT::scm_acDataOutputNames[] = {"OUT"};

const TEventID UINT2UINT::scm_nEventREQID = 0;
const TINT16 UINT2UINT::scm_anEIWithIndexes[] = {0};
const TDataIOID UINT2UINT::scm_anEIWith[] = {0, 255};
const TFBNameListEntry UINT2UINT::scm_acEventInputNames[] = {"REQ"};

const TEventID UINT2UINT::scm_nEventCNFID = 0;
const TDataIOID UINT2UINT::scm_anEOWith[] = {0, 255};
const TINT16 UINT2UINT::scm_anEOWithIndexes[] = {0, -1};
const TFBNameListEntry UINT2UINT::scm_acEventOutputNames[] = {"CNF"};

const SFBInterfaceSpec UINT2UINT::scm_stFBInterfaceSpec = {
  1,
  scm_acEventInputNames,
  scm_anEIWith,
  scm_anEIWithIndexes,
  1,
  scm_acEventOutputNames,
  scm_anEOWith,
  scm_anEOWithIndexes,
  1,
  scm_acDataInputNames,
  1,
  scm_acDataOutputNames
};

void UINT2UINT::alg_REQ(void){
OUT = IN;
}

const TINT16 UINT2UINT::scm_nStateSTART = 0;
const TINT16 UINT2UINT::scm_nStateREQ = 1;

void UINT2UINT::enterStateSTART(void){
  m_nECCState = scm_nStateSTART;
}

void UINT2UINT::enterStateREQ(void){
  m_nECCState = scm_nStateREQ;
  alg_REQ();
  sendOutputEvent( scm_nEventCNFID);
}

bool UINT2UINT::executeECCOnce(TEventID pa_nEIID){
  bool bRetVal = true;
  switch(m_nECCState){
    case scm_nStateSTART:
      if(scm_nEventREQID == pa_nEIID)
      	enterStateREQ();
      else
        bRetVal = false; //no transition cleared
      break;
    case scm_nStateREQ:
      if(1)
      	enterStateSTART();
      else
        bRetVal = false; //no transition cleared
      break;
    default:
      DEVLOG_ERROR(cg_nID_CFunctionBlock, 0x01 , "The ECC state is not in the valid range!");
      m_nECCState = 0; //0 is allways the initial state
      break;
  }
  return bRetVal;
}

UINT2UINT::UINT2UINT(CStringDictionary::TStringId pa_nAppl, CResource *pa_poSrcRes) : 
       CBasicFB(pa_nAppl,
           pa_poSrcRes,
           &scm_stFBInterfaceSpec,
           m_apoEOConns,
           m_apoDIConns,
           m_apoDIs,
           m_apoDOConns,
           m_apoDOs,
            0, 0, 0) {
  m_apoDIs[0] = &IN;
  m_apoDOs[0] = &OUT;
}
 
UINT2UINT::~UINT2UINT(){
}



