/*************************************************************************
 *** FORTE Library Element
 ***
 *** Name: WORD2WORD
 *** Description: Basic Function Block Type
 *** Version: 
 ***     1.0: 2006-11-14/TS - PROFACTOR GmbH - 
 *************************************************************************/

#ifndef _WORD2WORD_H_
#define _WORD2WORD_H_

#include <basicfb.h>
#include <forte_word.h>

class WORD2WORD: public CBasicFB{
  DECLARE_FIRMWARE_FB(WORD2WORD)

private:
  static const TFBNameListEntry scm_acDataInputNames[];
  CIEC_WORD IN;
  static const TFBNameListEntry scm_acDataOutputNames[];
  CIEC_WORD OUT;
  static const TEventID scm_nEventREQID;
  static const TINT16 scm_anEIWithIndexes[];
  static const TDataIOID scm_anEIWith[];
  static const TFBNameListEntry scm_acEventInputNames[];

  static const TEventID scm_nEventCNFID;
  static const TINT16 scm_anEOWithIndexes[];
  static const TDataIOID scm_anEOWith[];
  static const TFBNameListEntry scm_acEventOutputNames[];

  static const SFBInterfaceSpec scm_stFBInterfaceSpec;

  TEventConnectionPtr m_apoEOConns[1];
  TDataConnectionPtr m_apoDIConns[1];
  TIEC_ANYPtr m_apoDIs[1];
  TDataConnectionPtr m_apoDOConns[1];
  TIEC_ANYPtr m_apoDOs[1];
  void alg_REQ(void);
  static const TINT16 scm_nStateSTART;
  static const TINT16 scm_nStateREQ;

  void enterStateSTART(void);
  void enterStateREQ(void);

protected:
  virtual bool executeECCOnce(TEventID pa_nEIID);

public:
  WORD2WORD(CStringDictionary::TStringId pa_nAppl, CResource *pa_poSrcRes);
  virtual ~WORD2WORD();

};

#endif //close the ifdef sequence from the beginning of the file

