/*******************************************************************************
 * Copyright (c) 2007 4DIAC - consortium.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     <date>: <author>, <author email> - changes
 *     20080423: alil, alil@users.sourceforge.net - made e-blocks simple FBs in order to reduce size and increase performance
 *******************************************************************************/
#include "E_CTU.h"

DEFINE_FIRMWARE_FB(E_CTU)

const TFBNameListEntry E_CTU::scm_acDataInputNames[] = {"PV"};

const TFBNameListEntry E_CTU::scm_acDataOutputNames[] = {"Q", "CV"};

const TEventID E_CTU::scm_nEventCUID = 0;
const TEventID E_CTU::scm_nEventRID = 1;
const TINT16 E_CTU::scm_anEIWithIndexes[] = {0, -1};
const TDataIOID E_CTU::scm_anEIWith[] = {0, 255};
const TFBNameListEntry E_CTU::scm_acEventInputNames[] = {"CU", "R"};

const TEventID E_CTU::scm_nEventCUOID = 0;
const TEventID E_CTU::scm_nEventROID = 1;
const TDataIOID E_CTU::scm_anEOWith[] = {0, 1, 255, 0, 1, 255};
const TINT16 E_CTU::scm_anEOWithIndexes[] = {0, 3, -1};
const TFBNameListEntry E_CTU::scm_acEventOutputNames[] = {"CUO", "RO"};

void E_CTU::executeEvent(TEventID pa_nEIID){
  switch(pa_nEIID){
    case scm_nEventCUID:
      if(CV < 65535){
        CV = CV+1;
        Q = (CV >= PV);
        sendOutputEvent( scm_nEventCUOID);
      }
      break;
    case scm_nEventRID:
      CV = 0;
      Q = false;
      sendOutputEvent( scm_nEventROID);
      break;
    default:
      break;
  }
}

const SFBInterfaceSpec E_CTU::scm_stFBInterfaceSpec = {
  2,
  scm_acEventInputNames,
  scm_anEIWith,
  scm_anEIWithIndexes,
  2,
  scm_acEventOutputNames,
  scm_anEOWith,
  scm_anEOWithIndexes,
  1,
  scm_acDataInputNames,
  2,
  scm_acDataOutputNames,
};

E_CTU::E_CTU(CStringDictionary::TStringId pa_nAppl, CResource *pa_poSrcRes) : 
       CSimpleFB(pa_nAppl, pa_poSrcRes, &scm_stFBInterfaceSpec, m_apoEOConns, m_apoDIConns, m_apoDIs, m_apoDOConns, m_apoDOs){
  m_apoDIs[0] = &PV;
  m_apoDOs[0] = &Q;
  m_apoDOs[1] = &CV;
  
  
}



