/*******************************************************************************
 * Copyright (c) 2007 4DIAC - consortium.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     <date>: <author>, <author email> - changes
 *     20080423: alil, alil@users.sourceforge.net - made e-blocks simple FBs in order to reduce size and increase performance
 *******************************************************************************/
#ifndef _E_CTU_H_
#define _E_CTU_H_

#include <simplefb.h>
#include <forte_bool.h>
#include <forte_uint.h>

class E_CTU: public CSimpleFB{
  DECLARE_FIRMWARE_FB(E_CTU)

private:
  static const TFBNameListEntry scm_acDataInputNames[];
  CIEC_UINT PV;
  static const TFBNameListEntry scm_acDataOutputNames[];
  CIEC_BOOL Q;
  CIEC_UINT CV;
    
  static const TEventID scm_nEventCUID;
  static const TEventID scm_nEventRID;
  static const TINT16 scm_anEIWithIndexes[];
  static const TDataIOID scm_anEIWith[];
  static const TFBNameListEntry scm_acEventInputNames[];

  static const TEventID scm_nEventCUOID;
  static const TEventID scm_nEventROID;
  static const TINT16 scm_anEOWithIndexes[];
  static const TDataIOID scm_anEOWith[];
  static const TFBNameListEntry scm_acEventOutputNames[];
  
protected:
  virtual void executeEvent(TEventID pa_nEIID);

  static const SFBInterfaceSpec scm_stFBInterfaceSpec;

  TEventConnectionPtr m_apoEOConns[2];
  TDataConnectionPtr m_apoDIConns[1];
  TIEC_ANYPtr m_apoDIs[1];
  TDataConnectionPtr m_apoDOConns[2];
  TIEC_ANYPtr m_apoDOs[2];

public:
  E_CTU(CStringDictionary::TStringId pa_nAppl, CResource *pa_poSrcRes);
  virtual ~E_CTU(){};

};
#endif //close the ifdef sequence from the beginning of the file

