/*******************************************************************************
 * Copyright (c) 2007 4DIAC - consortium.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     <date>: <author>, <author email> - changes
 *      20080423: alil, alil@users.sourceforge.net - made e-blocks simple FBs in order to reduce size and increase performance
 *******************************************************************************/
#ifndef _E_DEMUX_H_
#define _E_DEMUX_H_

#include <simplefb.h>
#include <forte_uint.h>

class E_DEMUX: public CSimpleFB{
  DECLARE_FIRMWARE_FB(E_DEMUX)

private:
  static const TFBNameListEntry scm_acDataInputNames[];
  CIEC_UINT K;
    
  static const TEventID scm_nEventEIID;
  static const TINT16 scm_anEIWithIndexes[];
  static const TDataIOID scm_anEIWith[];
  static const TFBNameListEntry scm_acEventInputNames[];

  static const TEventID scm_nEventEO0ID;
  static const TEventID scm_nEventEO1ID;
  static const TEventID scm_nEventEO2ID;
  static const TEventID scm_nEventEO3ID;
  static const TINT16 scm_anEOWithIndexes[];
  static const TFBNameListEntry scm_acEventOutputNames[];
 
protected:
  virtual void executeEvent(TEventID pa_nEIID){
    if(scm_nEventEIID == pa_nEIID){
      if(K <= 3){
        sendOutputEvent( K); // the value of K corresponds to the outputevent ID;
                            // as a result of this we could make a generic E_DEMUX 
                            // and even a generic E_MUX
      }
    }
  };

  static const SFBInterfaceSpec scm_stFBInterfaceSpec;

  TEventConnectionPtr m_apoEOConns[4];
  TDataConnectionPtr m_apoDIConns[1];
  TIEC_ANYPtr m_apoDIs[1];

public:
  E_DEMUX(CStringDictionary::TStringId pa_nAppl, CResource *pa_poSrcRes): 
       CSimpleFB(pa_nAppl, pa_poSrcRes, &scm_stFBInterfaceSpec, m_apoEOConns, m_apoDIConns, m_apoDIs, 0, 0){
    m_apoDIs[0] = &K;
  };
  virtual ~E_DEMUX(){};

};
#endif //close the ifdef sequence from the beginning of the file

