/*******************************************************************************
 * Copyright (c) 2007 4DIAC - consortium.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     <date>: <author>, <author email> - changes
 *     20080423: alil, alil@users.sourceforge.net - made e-blocks simple FBs in order to reduce size and increase performance
 *******************************************************************************/
#include "E_D_FF.h"

DEFINE_FIRMWARE_FB(E_D_FF)

const TFBNameListEntry E_D_FF::scm_acDataInputNames[] = {"D"};

const TFBNameListEntry E_D_FF::scm_acDataOutputNames[] = {"Q"};

const TEventID E_D_FF::scm_nEventCLKID = 0;
const TINT16 E_D_FF::scm_anEIWithIndexes[] = {0};
const TDataIOID E_D_FF::scm_anEIWith[] = {0, 255};
const TFBNameListEntry E_D_FF::scm_acEventInputNames[] = {"CLK"};

const TEventID E_D_FF::scm_nEventEOID = 0;
const TDataIOID E_D_FF::scm_anEOWith[] = {0, 255};
const TINT16 E_D_FF::scm_anEOWithIndexes[] = {0, -1};
const TFBNameListEntry E_D_FF::scm_acEventOutputNames[] = {"EO"};

void E_D_FF::executeEvent(TEventID pa_nEIID){
  if(scm_nEventCLKID == pa_nEIID){
    if(D != Q){
      Q = D;
      sendOutputEvent( scm_nEventEOID);
    }
  }
}

const SFBInterfaceSpec E_D_FF::scm_stFBInterfaceSpec = {
  1,
  scm_acEventInputNames,
  scm_anEIWith,
  scm_anEIWithIndexes,
  1,
  scm_acEventOutputNames,
  scm_anEOWith,
  scm_anEOWithIndexes,
  1,
  scm_acDataInputNames,
  1,
  scm_acDataOutputNames,
};



