/*******************************************************************************
 * Copyright (c) 2007 4DIAC - consortium.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     <date>: <author>, <author email> - changes
 *     20080423: alil, alil@users.sourceforge.net - made e-blocks simple FBs in order to reduce size and increase performance
 *******************************************************************************/
#ifndef _E_PERMIT_H_
#define _E_PERMIT_H_

#include <simplefb.h>
#include <forte_bool.h>

class E_PERMIT: public CSimpleFB{
  DECLARE_FIRMWARE_FB(E_PERMIT)

private:
  static const TFBNameListEntry scm_acDataInputNames[];
  CIEC_BOOL PERMIT;
    
  static const TEventID scm_nEventEIID;
  static const TINT16 scm_anEIWithIndexes[];
  static const TDataIOID scm_anEIWith[];
  static const TFBNameListEntry scm_acEventInputNames[];

  static const TEventID scm_nEventEOID;
  static const TINT16 scm_anEOWithIndexes[];
  static const TFBNameListEntry scm_acEventOutputNames[];

protected:
  virtual void executeEvent(TEventID pa_nEIID){
    if((scm_nEventEIID == pa_nEIID) && (PERMIT)){
      sendOutputEvent(scm_nEventEOID);
    }
  };

  static const SFBInterfaceSpec scm_stFBInterfaceSpec;

  TEventConnectionPtr m_apoEOConns[1];
  TDataConnectionPtr m_apoDIConns[1];
  TIEC_ANYPtr m_apoDIs[1];

public:
  E_PERMIT(CStringDictionary::TStringId pa_nAppl, CResource *pa_poSrcRes) : CSimpleFB(pa_nAppl, pa_poSrcRes, &scm_stFBInterfaceSpec, m_apoEOConns, m_apoDIConns, m_apoDIs, 0, 0) {
    m_apoDIs[0] = &PERMIT;
  };
  virtual ~E_PERMIT(){};

};
#endif //close the ifdef sequence from the beginning of the file

