/*******************************************************************************
 * Copyright (c) 2007 4DIAC - consortium.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     <date>: <author>, <author email> - changes
 *     20080423: alil, alil@users.sourceforge.net - made e-blocks simple FBs in order to reduce size and increase performance
 *******************************************************************************/
#include "E_REND.h"

DEFINE_FIRMWARE_FB(E_REND)

const TEventID E_REND::scm_nEventEI1ID = 0;
const TEventID E_REND::scm_nEventEI2ID = 1;
const TEventID E_REND::scm_nEventRID = 2;
const TINT16 E_REND::scm_anEIWithIndexes[] = {-1, -1, -1};
const TFBNameListEntry E_REND::scm_acEventInputNames[] = {"EI1", "EI2", "R"};

const TEventID E_REND::scm_nEventEOID = 0;
const TINT16 E_REND::scm_anEOWithIndexes[] = {-1, -1};
const TFBNameListEntry E_REND::scm_acEventOutputNames[] = {"EO"};

void E_REND::executeEvent(TEventID pa_nEIID){
  switch(pa_nEIID){
    case scm_nEventEI1ID:
      if(m_bE2Occ){
        m_bE2Occ = false;
        sendOutputEvent( scm_nEventEOID);
      }
      else{
        m_bE1Occ = true;
      }
      break;
    case scm_nEventEI2ID:
      if(m_bE1Occ){
        m_bE1Occ = false;
        sendOutputEvent( scm_nEventEOID);
      }
      else{
        m_bE2Occ = true;
      }
      break;
    case scm_nEventRID:
      m_bE1Occ = m_bE2Occ = false;
      break;
    default:
      break;
  }
}

const SFBInterfaceSpec E_REND::scm_stFBInterfaceSpec = {
  3,
  scm_acEventInputNames,
  0,
  scm_anEIWithIndexes,
  1,
  scm_acEventOutputNames,
  0,
  scm_anEOWithIndexes,
  0,
  0,
  0,
  0,
};



