/*******************************************************************************
 * Copyright (c) 2007 4DIAC - consortium.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     <date>: <author>, <author email> - changes
 *     20080423: alil, alil@users.sourceforge.net - made e-blocks simple FBs in order to reduce size and increase performance
 *******************************************************************************/
#ifndef _E_REND_H_
#define _E_REND_H_

#include <simplefb.h>

class E_REND: public CSimpleFB{
  DECLARE_FIRMWARE_FB(E_REND)

private:
    
  static const TEventID scm_nEventEI1ID;
  static const TEventID scm_nEventEI2ID;
  static const TEventID scm_nEventRID;
  static const TINT16 scm_anEIWithIndexes[];
  static const TFBNameListEntry scm_acEventInputNames[];

  static const TEventID scm_nEventEOID;
  static const TINT16 scm_anEOWithIndexes[];
  static const TFBNameListEntry scm_acEventOutputNames[];

  static const int scm_nStateSTART;
  static const int scm_nStateR;
  static const int scm_nStateR1;
  static const int scm_nStateEI1;
  static const int scm_nStateEO;
  static const int scm_nStateEI2;
  static const int scm_nStateR2;
  
  bool m_bE1Occ;
  bool m_bE2Occ;

protected:
  virtual void executeEvent(TEventID pa_nEIID);

  static const SFBInterfaceSpec scm_stFBInterfaceSpec;

  TEventConnectionPtr m_apoEOConns[1];

public:
  E_REND(CStringDictionary::TStringId pa_nAppl, CResource *pa_poSrcRes) :  CSimpleFB(pa_nAppl, pa_poSrcRes, &scm_stFBInterfaceSpec, m_apoEOConns, 0, 0, 0, 0){
    m_bE1Occ = m_bE2Occ = false;
  };
  virtual ~E_REND() {};

};
#endif //close the ifdef sequence from the beginning of the file

