/*******************************************************************************
 * Copyright (c) 2007 4DIAC - consortium.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     <date>: <author>, <author email> - changes
 *******************************************************************************/
#ifndef _E_RESTART_H_
#define _E_RESTART_H_

#include "E_CYCLE.h"

/*! \brief Implementation of the E_RESTART FB.
 *  
 * @author AZ
 * @version 20060619/AZ+SMR - New FB-interface introduced
 * @version 20060207/AZ - Removed number of EOs in CFunctionBlock-Constructor
 * @version 20060206/AZ - Changed event connection handling
 * @version 20051208/AZ - changed sate machine to send cold events after reset
 * @version 20051022/AZ - Initial version as basis for the interface documentation
 */
class E_RESTART : public CEventSourceFB{
  DECLARE_FIRMWARE_FB(E_RESTART)
private:
  static const SFBInterfaceSpec scm_stFBInterfaceSpec;
   
  static const TEventID csm_nCOLDID, csm_nWARMID, csm_nSTOPID;
  
  static const TFBNameListEntry scm_acEONames[]; 
  static const TINT16 scm_anEOWithIndexes[];
  TEventConnectionPtr m_apoEOConns[3]; 
  
  bool m_bStartedOnce;
    
  
protected:
  virtual void executeEvent(TEventID pa_nEIID);
  
public:
	E_RESTART(CStringDictionary::TStringId pa_nAppl, CResource *pa_poSrcRes);
	virtual ~E_RESTART() {};
  
  virtual EMGMResponse startManagedObject(void);
  virtual EMGMResponse stopManagedObject(void);
  virtual EMGMResponse resetManagedObject(void);   
};

#endif /*E_RESTART_H_*/
