/*******************************************************************************
 * Copyright (c) 2007 4DIAC - consortium.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     <date>: <author>, <author email> - changes
 *     20080423: alil, alil@users.sourceforge.net - made e-blocks simple FBs in order to reduce size and increase performance
 *******************************************************************************/
#ifndef _E_RS_H_
#define _E_RS_H_

#include <simplefb.h>
#include <forte_bool.h>

class E_RS: public CSimpleFB{
  DECLARE_FIRMWARE_FB(E_RS)

private:
  static const TFBNameListEntry scm_acDataOutputNames[];
  CIEC_BOOL Q;
    
  static const TEventID scm_nEventRID;
  static const TEventID scm_nEventSID;
  static const TINT16 scm_anEIWithIndexes[];
  static const TFBNameListEntry scm_acEventInputNames[];

  static const TEventID scm_nEventEOID;
  static const TINT16 scm_anEOWithIndexes[];
  static const TDataIOID scm_anEOWith[];
  static const TFBNameListEntry scm_acEventOutputNames[];
  
 protected:
  virtual void executeEvent(TEventID pa_nEIID);

  static const SFBInterfaceSpec scm_stFBInterfaceSpec;

  TEventConnectionPtr m_apoEOConns[1];
  TDataConnectionPtr m_apoDOConns[1];
  TIEC_ANYPtr m_apoDOs[1];

public:
  E_RS(CStringDictionary::TStringId pa_nAppl, CResource *pa_poSrcRes) : CSimpleFB(pa_nAppl, pa_poSrcRes, &scm_stFBInterfaceSpec, m_apoEOConns, 0, 0, m_apoDOConns, m_apoDOs){
    m_apoDOs[0] = &Q;
  };
  virtual ~E_RS() {};

};
#endif //close the ifdef sequence from the beginning of the file

