/*******************************************************************************
 * Copyright (c) 2007 4DIAC - consortium.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     <date>: <author>, <author email> - changes
 *     20080423: alil, alil@users.sourceforge.net - made e-blocks simple FBs in order to reduce size and increase performance
 *******************************************************************************/
#include "E_R_TRIG.h"
#include <typelib.h>

DEFINE_FIRMWARE_FB(E_R_TRIG)

const TFBNameListEntry E_R_TRIG::scm_acDataInputNames[] = {"QI"};

const TEventID E_R_TRIG::scm_nEventEIID = 0;
const TINT16 E_R_TRIG::scm_anEIWithIndexes[] = {0};
const TDataIOID E_R_TRIG::scm_anEIWith[] = {0, 255};
const TFBNameListEntry E_R_TRIG::scm_acEventInputNames[] = {"EI"};

const TEventID E_R_TRIG::scm_nEventEOID = 0;
const TINT16 E_R_TRIG::scm_anEOWithIndexes[] = {-1, -1};
const TFBNameListEntry E_R_TRIG::scm_acEventOutputNames[] = {"EO"};

const SFBInterfaceSpec E_R_TRIG::scm_stFBInterfaceSpec = {
  1,
  scm_acEventInputNames,
  scm_anEIWith,
  scm_anEIWithIndexes,
  1,
  scm_acEventOutputNames,
  0,
  scm_anEOWithIndexes,
  1,
  scm_acDataInputNames,
  0,
  0
};

void E_R_TRIG::executeEvent(TEventID pa_nEIID){
  if(scm_nEventEIID == pa_nEIID){
    if((m_bOldVal != QI) && (true == QI)){ 
      //Raising edge
      sendOutputEvent(scm_nEventEOID);
    }
    m_bOldVal = QI;
  }
}



