/*******************************************************************************
 * Copyright (c) 2007 4DIAC - consortium.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     <date>: <author>, <author email> - changes
 *     20080423: alil, alil@users.sourceforge.net - made e-blocks simple FBs in order to reduce size and increase performance
 *******************************************************************************/
#ifndef _E_R_TRIG_H_
#define _E_R_TRIG_H_

#include <simplefb.h>
#include <forte_bool.h>

class E_R_TRIG: public CSimpleFB{
  DECLARE_FIRMWARE_FB(E_R_TRIG)

private:
  static const TFBNameListEntry scm_acDataInputNames[];
  CIEC_BOOL QI;
  static const TEventID scm_nEventEIID;
  static const TINT16 scm_anEIWithIndexes[];
  static const TDataIOID scm_anEIWith[];
  static const TFBNameListEntry scm_acEventInputNames[];

  static const TEventID scm_nEventEOID;
  static const TINT16 scm_anEOWithIndexes[];
  static const TFBNameListEntry scm_acEventOutputNames[];

  static const SFBInterfaceSpec scm_stFBInterfaceSpec;

  TEventConnectionPtr m_apoEOConns[1];
  TDataConnectionPtr m_apoDIConns[1];
  TIEC_ANYPtr m_apoDIs[1];

  bool m_bOldVal;
protected:
  void executeEvent(TEventID pa_nEIID);

public:
  E_R_TRIG(CStringDictionary::TStringId pa_nAppl, CResource *pa_poSrcRes) :  CSimpleFB(pa_nAppl, pa_poSrcRes, &scm_stFBInterfaceSpec, m_apoEOConns, m_apoDIConns, m_apoDIs, 0, 0){
    m_apoDIs[0] = &QI;
    m_bOldVal = false;
  };
  virtual ~E_R_TRIG(){};

};

#endif //close the ifdef sequence from the beginning of the file

