/*******************************************************************************
 * Copyright (c) 2007 4DIAC - consortium.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     <date>: <author>, <author email> - changes
 *     20080423: alil, alil@users.sourceforge.net - made e-blocks simple FBs in order to reduce size and increase performance
 *******************************************************************************/
#include "E_SELECT.h"

DEFINE_FIRMWARE_FB(E_SELECT)

const TFBNameListEntry E_SELECT::scm_acDataInputNames[] = {"G"};

const TEventID E_SELECT::scm_nEventEI0ID = 0;
const TEventID E_SELECT::scm_nEventEI1ID = 1;
const TINT16 E_SELECT::scm_anEIWithIndexes[] = {0, 2};
const TDataIOID E_SELECT::scm_anEIWith[] = {0, 255, 0, 255};
const TFBNameListEntry E_SELECT::scm_acEventInputNames[] = {"EI0", "EI1"};

const TEventID E_SELECT::scm_nEventEOID = 0;
const TINT16 E_SELECT::scm_anEOWithIndexes[] = {-1, -1};
const TFBNameListEntry E_SELECT::scm_acEventOutputNames[] = {"EO"};

void E_SELECT::executeEvent(TEventID pa_nEIID){
  switch(pa_nEIID){
    case scm_nEventEI0ID:
      if(false == G){
        sendOutputEvent( scm_nEventEOID);
      }
      break;
    case scm_nEventEI1ID:
      if(true == G){
        sendOutputEvent( scm_nEventEOID);
      }
      break;
    default:
      break;
  }
}

const SFBInterfaceSpec E_SELECT::scm_stFBInterfaceSpec = {
  2,
  scm_acEventInputNames,
  scm_anEIWith,
  scm_anEIWithIndexes,
  1,
  scm_acEventOutputNames,
  0,
  scm_anEOWithIndexes,
  1,
  scm_acDataInputNames,
  0,
  0,
};

