/*******************************************************************************
 * Copyright (c) 2007 4DIAC - consortium.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     <date>: <author>, <author email> - changes
 *     20080423: alil, alil@users.sourceforge.net - made e-blocks simple FBs in order to reduce size and increase performance
 *******************************************************************************/
#ifndef _E_SPLIT_H_
#define _E_SPLIT_H_

#include <simplefb.h>

class E_SPLIT: public CSimpleFB{
  DECLARE_FIRMWARE_FB(E_SPLIT)

private:
  static const TEventID scm_nEventEIID;
  static const TINT16 scm_anEIWithIndexes[];
  static const TFBNameListEntry scm_acEventInputNames[];

  static const TEventID scm_nEventEO1ID;
  static const TEventID scm_nEventEO2ID;
  static const TINT16 scm_anEOWithIndexes[];
  static const TFBNameListEntry scm_acEventOutputNames[];

protected:
  virtual void executeEvent(TEventID pa_nEIID){
    if(scm_nEventEIID == pa_nEIID){
      sendOutputEvent( scm_nEventEO1ID);
      sendOutputEvent( scm_nEventEO2ID);
    }
  };

  static const SFBInterfaceSpec scm_stFBInterfaceSpec;

  TEventConnectionPtr m_apoEOConns[2];
public:
  E_SPLIT(CStringDictionary::TStringId pa_nAppl, CResource *pa_poSrcRes) : CSimpleFB(pa_nAppl, pa_poSrcRes, &scm_stFBInterfaceSpec, m_apoEOConns, 0, 0, 0, 0){
  };
  virtual ~E_SPLIT(){};

};
#endif //close the ifdef sequence from the beginning of the file

