/*******************************************************************************
 * Copyright (c) 2007 4DIAC - consortium.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     <date>: <author>, <author email> - changes
 *     20080423: alil, alil@users.sourceforge.net - made e-blocks simple FBs in order to reduce size and increase performance
 *******************************************************************************/
#include "E_SR.h"

DEFINE_FIRMWARE_FB(E_SR)

const TFBNameListEntry E_SR::scm_acDataOutputNames[] = {"Q"};

const TEventID E_SR::scm_nEventSID = 0;
const TEventID E_SR::scm_nEventRID = 1;
const TINT16 E_SR::scm_anEIWithIndexes[] = {-1, -1};
const TFBNameListEntry E_SR::scm_acEventInputNames[] = {"S", "R"};

const TEventID E_SR::scm_nEventEOID = 0;
const TDataIOID E_SR::scm_anEOWith[] = {0, 255};
const TINT16 E_SR::scm_anEOWithIndexes[] = {0, -1};
const TFBNameListEntry E_SR::scm_acEventOutputNames[] = {"EO"};

void E_SR::executeEvent(TEventID pa_nEIID){
  switch(pa_nEIID){
    case scm_nEventSID:
      if(false == Q){
        Q = true;
        sendOutputEvent( scm_nEventEOID);
      }
      break;  
    case scm_nEventRID:
      if(true == Q){
        Q = false;
        sendOutputEvent( scm_nEventEOID);
      }
      break;   
    default:
      break;
  }
}

const SFBInterfaceSpec E_SR::scm_stFBInterfaceSpec = {
  2,
  scm_acEventInputNames,
  0,
  scm_anEIWithIndexes,
  1,
  scm_acEventOutputNames,
  scm_anEOWith,
  scm_anEOWithIndexes,
  0,
  0,
  1,
  scm_acDataOutputNames,
};



