/*******************************************************************************
 * Copyright (c) 2007 4DIAC - consortium.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     <date>: <author>, <author email> - changes
 *******************************************************************************/
#ifndef _DM_KRNL_H_
#define _DM_KRNL_H_

#include <cfb.h>
#include <forte_wstring.h>
#include <forte_bool.h>

class DM_KRNL: public CCompositeFB{
  DECLARE_FIRMWARE_FB(DM_KRNL)

private:
  static const TFBNameListEntry scm_acDataInputNames[];
  CIEC_BOOL QI;
  CIEC_WSTRING ID;
  static const TFBNameListEntry scm_acDataOutputNames[];
  CIEC_BOOL QO;
  CIEC_WSTRING STATUS;
    
  static const TEventID scm_nEventINITID;
  static const TINT16 scm_anEIWithIndexes[];
  static const TDataIOID scm_anEIWith[];
  static const TFBNameListEntry scm_acEventInputNames[];

  static const TEventID scm_nEventINITOID;
  static const TINT16 scm_anEOWithIndexes[];
  static const TDataIOID scm_anEOWith[];
  static const TFBNameListEntry scm_acEventOutputNames[];
  
  

  static const SFBInterfaceSpec scm_stFBInterfaceSpec;

  TEventConnectionPtr m_apoEOConns[1];
  TDataConnectionPtr m_apoDIConns[2];
  TIEC_ANYPtr m_apoDIs[2];
  TDataConnectionPtr m_apoDOConns[2];
  TIEC_ANYPtr m_apoDOs[2];
  

  static const TUINT16 m_nNumInternalFBs;
  TFunctionBlockPtr m_apoInternalFBs[2];

  CInternal2InterfaceEventConnection m_oEventConnection_SVR_INITO;
  CEventConnection m_oEventConnection_SVR_IND;
  CEventConnection m_oEventConnection_MGR_CNF;
  CEventConnection m_oEventConnection_INIT;
  CEventConnection m_oEventConnection_MGR_INITO;

  CInterface2InternalDataConnection m_oDataConnection_QI;
  CInterface2InternalDataConnection m_oDataConnection_ID;
  CInternal2InterfaceDataConnection m_oDataConnection_SVR_STATUS;
  CInternal2InterfaceDataConnection m_oDataConnection_SVR_QO;
  CDataConnection m_oDataConnection_SVR_RD_2;
  CDataConnection m_oDataConnection_MGR_QO;
  CDataConnection m_oDataConnection_MGR_RESP;
  CDataConnection m_oDataConnection_SVR_RD_1;

  TCInterface2InternalDataConnectionPtr m_apoIf2InDConns[2];
  TCInternal2InterfaceDataConnectionPtr m_apoIn2IfDConns[2];

protected:
  void executeEvent(TEventID pa_nEIID);

public:
  DM_KRNL(CStringDictionary::TStringId pa_nAppl, CResource *pa_poSrcRes);
  virtual ~DM_KRNL();

};

#endif //close the ifdef sequence from the beginning of the file

