/*******************************************************************************
 * Copyright (c) 2007 4DIAC - consortium.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     <date>: <author>, <author email> - changes
 *******************************************************************************/
#include "RMT_DEV.h"
#include "../../core/stringdict.h"

const TFBNameListEntry RMT_DEV::scm_acDINames[] = {"MGR_ID"};

const SFBInterfaceSpec RMT_DEV::scm_stFBInterfaceSpec = {
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  1,
  scm_acDINames,
  0,
  0,
};

RMT_DEV::RMT_DEV() :
         CDevice(&scm_stFBInterfaceSpec, m_apoDIConns, m_apoDIs),
         m_oDConnMGR_ID(CConnection::genConPortIdSingle("MGR_ID"), &MGR_ID),
         MGR(*this){
  m_apoDIs[0] = &MGR_ID;
  MGR_ID.fromString("localhost:61499");
  m_oDConnMGR_ID.connect(CConnection::genConPortId("MGR","MGR_ID"), *this, MGR, "MGR_ID");
}

RMT_DEV::~RMT_DEV(){
}

int RMT_DEV::startDevice(void){
  CDevice::startDevice();
  MGR.startManagedObject();
  return 0;
}

EMGMResponse RMT_DEV::killManagedObject(void){
  EMGMResponse retVal = CDevice::killManagedObject();
  if(retVal == e_RDY)
    MGR.killManagedObject();
  return retVal;
}
