/*******************************************************************************
 * Copyright (c) 2007 4DIAC - consortium.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     <date>: <author>, <author email> - changes
 *******************************************************************************/
#ifndef _RMT_DEV_H_
#define _RMT_DEV_H_

#include <device.h>
#include <if2indco.h>
#include <forte_wstring.h>
#include "RMT_RES.h"

/*! \brief Implementation of the RMT_DEV.
 *
 * @author unknown
 * @version 20081121/mmm - removed getDataInput because it is dead code
 */


class RMT_DEV : public CDevice{

  CInterface2InternalDataConnection m_oDConnMGR_ID;

  static const SFBInterfaceSpec scm_stFBInterfaceSpec;
  static const TFBNameListEntry scm_acDINames[];


  TDataConnectionPtr m_apoDIConns[1];
  TIEC_ANYPtr m_apoDIs[1];


  CIEC_WSTRING MGR_ID;

protected:
public:
  RMT_RES MGR;

	RMT_DEV();
	virtual ~RMT_DEV();

/*! \brief Adds additional functionality to the originals exeucte func of the device.
 *
 * This is that it waits till the thread of the MGR resource has anded
 */
	virtual int startDevice(void);

  virtual EMGMResponse killManagedObject(void);

  void setMGR_ID(string sConn){
    MGR_ID.fromString(sConn);
  };
};

#endif /*RMT_DEV_H_*/
