/*******************************************************************************
 * Copyright (c) 2007 4DIAC - consortium.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     <date>: <author>, <author email> - changes
 *******************************************************************************/
#include "RMT_RES.h"

DEFINE_FIRMWARE_RESOURCE(RMT_RES);

const TFBNameListEntry RMT_RES::scm_acVarInputNames[] = {"MGR_ID"};



const SFBInterfaceSpec RMT_RES::scm_stRESInterfaceSpec = {
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  1,
  scm_acVarInputNames,
  0,
  0
};

RMT_RES::RMT_RES(CDevice &pa_roDevice) : 
       CResource(pa_roDevice, &scm_stRESInterfaceSpec, m_apoVarConns, m_apoVars){
  m_apoVars[0] = &MGR_ID;
  createFB(CStringDictionary::getInstance().insert("START"),
           CStringDictionary::getInstance().insert("E_RESTART"), "");
  createFB(CStringDictionary::getInstance().insert("MGR_FF"),
           CStringDictionary::getInstance().insert("E_SR"), "");
  createFB(CStringDictionary::getInstance().insert("KERNEL"),
           CStringDictionary::getInstance().insert("DM_KRNL"), "");
  createConnection(CConnection::genConPortId("START", "COLD"),
                   CConnection::genConPortId("MGR_FF", "S"));
  createConnection(CConnection::genConPortId("START", "WARM"),
                   CConnection::genConPortId("MGR_FF", "S"));
  createConnection(CConnection::genConPortId("START", "STOP"),
                   CConnection::genConPortId("MGR_FF", "R"));
  createConnection(CConnection::genConPortId("MGR_FF", "EO"),
                   CConnection::genConPortId("KERNEL", "INIT"));
  createConnection(CConnection::genConPortId("MGR_FF", "Q"),
                   CConnection::genConPortId("KERNEL", "QI"));
  createConnection(CConnection::genConPortIdSingle("MGR_ID"), 
                   CConnection::genConPortId("KERNEL", "ID"));
}

RMT_RES::~RMT_RES(){
}



