/*************************************************************************
 *** FORTE Library Element
 ***
 *** Name: FB_ADD_LREAL
 *** Description: Adds two LREAL values
 *** Version: 
 ***     1.0: 2007-06-26/TS - PROFACTOR GmbH - 
 *************************************************************************/

#ifndef _FB_ADD_LREAL_H_
#define _FB_ADD_LREAL_H_

#include <basicfb.h>
#include <forte_lreal.h>


class FB_ADD_LREAL: public CBasicFB{
  DECLARE_FIRMWARE_FB(FB_ADD_LREAL)

private:
  static const TFBNameListEntry scm_acDataInputNames[];
  CIEC_LREAL IN1;
  CIEC_LREAL IN2;
  static const TFBNameListEntry scm_acDataOutputNames[];
  CIEC_LREAL OUT;
  static const TEventID scm_nEventREQID;
  static const TINT16 scm_anEIWithIndexes[];
  static const TDataIOID scm_anEIWith[];
  static const TFBNameListEntry scm_acEventInputNames[];

  static const TEventID scm_nEventCNFID;
  static const TINT16 scm_anEOWithIndexes[];
  static const TDataIOID scm_anEOWith[];
  static const TFBNameListEntry scm_acEventOutputNames[];

  static const SFBInterfaceSpec scm_stFBInterfaceSpec;

  TEventConnectionPtr m_apoEOConns[1];
  TDataConnectionPtr m_apoDIConns[2];
  TIEC_ANYPtr m_apoDIs[2];
  TDataConnectionPtr m_apoDOConns[1];
  TIEC_ANYPtr m_apoDOs[1];
  void alg_REQ(void);
  static const TINT16 scm_nStateSTART;
  static const TINT16 scm_nStateREQ;

  void enterStateSTART(void);
  void enterStateREQ(void);

protected:
  virtual bool executeECCOnce(TEventID pa_nEIID);

public:
  FB_ADD_LREAL(CStringDictionary::TStringId pa_nAppl, CResource *pa_poSrcRes);
  virtual ~FB_ADD_LREAL();

};

#endif //close the ifdef sequence from the beginning of the file

