/*******************************************************************************
 * Copyright (c) 2007 4DIAC - consortium.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     <date>: <author>, <author email> - changes
 *******************************************************************************/
#ifndef _GEN_CLIENT_H_
#define _GEN_CLIENT_H_

#include "../netcommfb.h"

/*! \brief Implementation of the CLIENT_* SIFB.
 *
 * @author SMR
 * @version 20081121/mmm - minor changes due to elimination of ANY_FACADE
 * @version 20071029/AZ - fixed bug in delete of data in the destructor
 * @version 20060718/SMR - revised version
 * @version 20060619/SMR - Introduced new FB interface
 * @version 20060322/SMR - First usable version, various changes
 */

class GEN_CLIENT : public CNetCommFB {
DECLARE_GENERIC_FB(GEN_CLIENT)

private:
  static const TFBNameListEntry scm_acEventInputNames[];
  static const TFBNameListEntry scm_acEventOutputNames[];

  static const TINT16 scm_anEIWidthIndexes[];
  static const TINT16 scm_anEOWidthIndexes[];
  static const SFBInterfaceSpec scm_stFBInterfaceSpec;
  TEventConnectionPtr m_apoEOConns[2];

  static const TEventID scm_nEventINITID;
  static const TEventID scm_nEventREQID;
  static const TEventID scm_nEventINITOID;
  static const TEventID scm_nEventCNFID;
  static const int scm_nRecvBufferSize;
  static const int scm_nSendBufferSize;


public:
  GEN_CLIENT(CStringDictionary::TStringId pa_nAppl, CResource *pa_poSrcRes);
  virtual ~GEN_CLIENT();
  virtual void executeEvent(TEventID pa_nEIID);
};

#endif //_GEN_CLIENT_H_
