/*******************************************************************************
 * Copyright (c) 2007 4DIAC - consortium.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     <date>: <author>, <author email> - changes
 *******************************************************************************/
#include "GEN_PUBL.h"
#include "../../core/resource.h"

DEFINE_GENERIC_FB(GEN_PUBL)

const TFBNameListEntry GEN_PUBL::scm_acEventInputNames[2] = {"INIT", "REQ"};
const TFBNameListEntry GEN_PUBL::scm_acEventOutputNames[2] = {"INITO", "CNF"};
const TINT16 GEN_PUBL::scm_anEIWidthIndexes[2] = {-1, -1};
const TINT16 GEN_PUBL::scm_anEOWidthIndexes[3] = {-1, -1, -1};



const SFBInterfaceSpec GEN_PUBL::scm_stFBInterfaceSpec = { \
  2, \
  scm_acEventInputNames, \
  0, \
  scm_anEIWidthIndexes, \
  2, \
  scm_acEventOutputNames, \
  0, \
  scm_anEOWidthIndexes, \
  0, \
  0, \
  0, \
  0
};

const TEventID GEN_PUBL::scm_nEventINITID = 0;
const TEventID GEN_PUBL::scm_nEventREQID = 1;
const TEventID GEN_PUBL::scm_nEventINITOID = 0;
const TEventID GEN_PUBL::scm_nEventCNFID = 1;

void  GEN_PUBL::executeEvent(TEventID pa_nEIID){
  switch(pa_nEIID) {
    case scm_nEventINITID:
      if (m_sID.length() != 0) // unregister if we are still registered
      	unregisterPublFB(m_sID);
      // Reading Inputs accoriding to with construct
      if (0 != m_poID)
        m_poID->readData(&ID);
      m_sID = ID.getValue();
      m_plocalCommGroup = registerPublFB(m_sID);
  		//Sending INITO output event
  		sendOutputEvent(scm_nEventINITOID);
      break;
    case scm_nEventREQID:
      for (unsigned int i=0;i<m_nNumDataInput;i++) {
        if (0 != m_poSD[i] && SD[i] != 0){
          (m_poSD[i])->readData(SD[i]);
        }  
      }
      notify(m_plocalCommGroup);
      // Sending CNF output event
      sendOutputEvent(scm_nEventCNFID);
      break;
  default:
      ; // doing something here ??
   }
}

GEN_PUBL::GEN_PUBL(CStringDictionary::TStringId pa_nAppl, CResource *pa_poSrcRes):
          CLocalCommFB(pa_nAppl, pa_poSrcRes, &scm_stFBInterfaceSpec,m_apoEOConns) {
 m_sID = "";


}

GEN_PUBL::~GEN_PUBL(){
 unregisterPublFB(m_sID);
}

