/*******************************************************************************
 * Copyright (c) 2007 4DIAC - consortium.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     <date>: <author>, <author email> - changes
 *    20080425: ih, hegny@acin.tuwien.ac.at    - adopted behaviour of Publish-FBs to meet the new Version of compliance profile for feasibility studies
 *    20071029: az, alil@users.sourceforge.net - fixed bug in delte of data in the destructor
 *******************************************************************************/
#include <string.h>
#include "GEN_PUBLISH.h"
#include "../../core/resource.h"



DEFINE_GENERIC_FB(GEN_PUBLISH)

const TFBNameListEntry GEN_PUBLISH::scm_acEventInputNames[2] = {"INIT", "REQ"};
const TFBNameListEntry GEN_PUBLISH::scm_acEventOutputNames[2] = {"INITO", "CNF"};
const TINT16 GEN_PUBLISH::scm_anEIWidthIndexes[2] = {-1, -1};
const TINT16 GEN_PUBLISH::scm_anEOWidthIndexes[3] = {-1, -1, -1};



const SFBInterfaceSpec GEN_PUBLISH::scm_stFBInterfaceSpec = { \
  2, \
  scm_acEventInputNames, \
  0, \
  scm_anEIWidthIndexes, \
  2, \
  scm_acEventOutputNames, \
  0, \
  scm_anEOWidthIndexes, \
  0, \
  0, \
  0, \
  0
};

const TEventID GEN_PUBLISH::scm_nEventINITID = 0;
const TEventID GEN_PUBLISH::scm_nEventREQID = 1;
const TEventID GEN_PUBLISH::scm_nEventINITOID = 0;
const TEventID GEN_PUBLISH::scm_nEventCNFID = 1;

const int GEN_PUBLISH::scm_nSendBufferSize = 200; //TODO: Check this value!


void  GEN_PUBLISH::executeEvent(TEventID pa_nEIID){

 // TODO: Check return values of the called functions and set correct Status Message
  switch(pa_nEIID) {
    case scm_nEventINITID:
      // Reading Inputs according to with construct
      if (0 != m_poQI)
        m_poQI->readData(&QI);
      if (0 != m_poID)
        m_poID->readData(&ID);
      QO = QI;
      if (QI == true){ //INIT+
        //connect the SIFB to the socket handler
        strncpy(stConnectionInformation.m_pcConnectionID, ID, 31);
        stConnectionInformation.m_pcConnectionID[31] = '\0';
        if (m_roSocketHandler.registerSocketFB(stConnectionInformation) != 0)
          STATUS=scm_sResponseTexts[0]; //OK
        else {
          QO = false;
          STATUS=scm_sResponseTexts[1]; // INVALID_ID
        }
      }
      else { //INIT-
        //disconnect the SIFB from the socket handler
        m_roSocketHandler.unregisterSocketFB(this);
        STATUS = scm_sResponseTexts[2]; //TERMINATED
      }
      // Writing output data according to with construct
      if (0 != m_poQO)
          m_poQO->writeData(&QO);
      if (0 != m_poSTATUS)
          m_poSTATUS->writeData(&STATUS);
      // Sending INITO output event
      sendOutputEvent(scm_nEventINITOID);
      break;
    case scm_nEventREQID:
      // Reading Inputs accoriding to with construct
      if (0 != m_poQI)
          m_poQI->readData(&QI);
      for (unsigned int i=0;i<m_nNumDataInput;i++) {
        if (0 != m_poSD[i] && SD[i] != 0)
            (m_poSD[i])->readData(SD[i]);
      }
      if(QI == true){
        if (sendData()!= 0) {
          QO = false;
          STATUS = scm_sResponseTexts[2]; //TERMINATED
        }
        else {
          QO = true;
          STATUS = scm_sResponseTexts[0]; //OK
        }
      }
      else{
        QO = false;
        STATUS = scm_sResponseTexts[5]; //INHIBITED
      }

      // Writing output data according to with construct
      if (0 != m_poQO)
          m_poQO->writeData(&QO);
      if (0 != m_poSTATUS)
          m_poSTATUS->writeData(&STATUS);
      if ((QI==false) || (QO==true)) {
      // Sending CNF output event
      sendOutputEvent(scm_nEventCNFID);
      }
      else {
        sendOutputEvent(scm_nEventINITOID);
      }
      break;
  default:
      ; // doing something here ??
   }
}

GEN_PUBLISH::GEN_PUBLISH(CStringDictionary::TStringId pa_nAppl, CResource *pa_poSrcRes):
          CNetCommFB(pa_nAppl, pa_poSrcRes, &scm_stFBInterfaceSpec,m_apoEOConns){

  setEventChainExecutor(pa_poSrcRes->getResourceEventExecution());
//  INITO=0;
//  IND=0;
  stSendBuffer.m_pcData = new TBYTE[scm_nSendBufferSize];
  if (stSendBuffer.m_pcData == 0)
    DEVLOG_DEBUG(cg_nID_Publish, 0x01, "unable to allocate memory for sendbuffer\n");
  stSendBuffer.m_nFilledSize = 0;
  stSendBuffer.m_nMaxSize = scm_nSendBufferSize;
  stSendBuffer.m_enConnectionState = CSocketHandler::e_Unconnected;

  stConnectionInformation.m_poSocketFB = this;
  stConnectionInformation.m_pstSendBuffer = &stSendBuffer;
  stConnectionInformation.m_pstRecvBuffer = 0;
  stConnectionInformation.m_enServiceType = CSocketHandler::e_Publisher;

  strncpy(stConnectionInformation.m_pcConnectionID, "10.0.0.0:61499", 31);
}

GEN_PUBLISH::~GEN_PUBLISH(){
  m_roSocketHandler.unregisterSocketFB(this);
  delete[] stSendBuffer.m_pcData;
}
