/*******************************************************************************
 * Copyright (c) 2007 4DIAC - consortium.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     <date>: <author>, <author email> - changes
 *******************************************************************************/
#ifndef _GEN_SERCOMM_H_
#define _GEN_SERCOMM_H_

#include "../sercommfb.h"
#include "../core/datatypes/forte_udint.h"

/*! \brief Implementation of the SERCOM_* SIFB.
 *
 * @author jbrunn
 * @version 20081121/mmm - minor changes due to elimination of ANY_FACADE
 * @version 20071029/AZ - fixed bug in delete of data in the destructor
 * @version 20061204/jbrunn - Changed service type
 * @version 20061201/jbrunn - Worked on documentation and changed maximum buffer size
 * @version 20061130/jbrunn - Minor changes
 * @version 20061128/jbrunn - First working version
 * @version 20061127/jbrunn - Initial version of the SERCOMM SIFB
 */

class GEN_SERCOMM: public CSerCommFB {
DECLARE_FIRMWARE_FB(GEN_SERCOMM)

private:
  static const TFBNameListEntry scm_acEventInputNames[];
  static const TFBNameListEntry scm_acEventOutputNames[];

  static const TINT16 scm_anEIWidthIndexes[];
  static const TINT16 scm_anEOWidthIndexes[];
  static const SFBInterfaceSpec scm_stFBInterfaceSpec;
  TEventConnectionPtr m_apoEOConns[2];

  static const TEventID scm_nEventINITID;
  static const TEventID scm_nEventREQID;
  static const TEventID scm_nEventINITOID;
  static const TEventID scm_nEventINDID;
  static const int scm_nRecvBufferSize;
  static const int scm_nSendBufferSize;


/*!\brief Internal function called when an INIT Event arrives
 */
  void initEvent(void);
/*!\brief Internal function called when a REQ Event arrives
 */
  void requestEvent(void);
/*!\brief Internal function called when network-data arrives
 */
  void externalEvent(void);

protected:
  virtual void executeEvent(TEventID pa_nEIID);

public:
  GEN_SERCOMM(CStringDictionary::TStringId pa_nAppl, CResource *pa_poSrcRes);
  virtual ~GEN_SERCOMM();
};

#endif //_GEN_SERCOMM_H_
