/*******************************************************************************
 * Copyright (c) 2007 4DIAC - consortium.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     <date>: <author>, <author email> - changes
 *******************************************************************************/
#include "GEN_SUBL.h"
#include "../../core/resource.h"

DEFINE_GENERIC_FB(GEN_SUBL)

const TFBNameListEntry GEN_SUBL::scm_acEventInputNames[1] = {"INIT"};
const TFBNameListEntry GEN_SUBL::scm_acEventOutputNames[2] = {"INITO", "IND"};
const TINT16 GEN_SUBL::scm_anEIWidthIndexes[1] = {-1};
const TINT16 GEN_SUBL::scm_anEOWidthIndexes[3] = {-1, -1, -1};



const SFBInterfaceSpec GEN_SUBL::scm_stFBInterfaceSpec = { \
  1, \
  scm_acEventInputNames, \
  0, \
  scm_anEIWidthIndexes, \
  2, \
  scm_acEventOutputNames, \
  0, \
  scm_anEOWidthIndexes, \
  0, \
  0, \
  0, \
  0
};

const TEventID GEN_SUBL::scm_nEventINITID = 0;
const TEventID GEN_SUBL::scm_nEventRSPID = 1;
const TEventID GEN_SUBL::scm_nEventINITOID = 0;
const TEventID GEN_SUBL::scm_nEventINDID = 1;

void  GEN_SUBL::executeEvent(TEventID pa_nEIID){
  switch(pa_nEIID) {
    case scm_nEventINITID:
      if (m_sID.length() != 0) // unregister if we are still registered
      	unregisterSublFB(m_sID);
      if (0 != m_poID)
          m_poID->readData(&ID);
        //connect the SIFB to the socket handler
      m_sID = ID.getValue();
      registerSublFB(m_sID);
      sendOutputEvent(scm_nEventINITID);
      break;
   case cg_nExternalEventID:
     for (unsigned int i=0;i<m_nNumDataOutput;i++) {
       if (0 != m_poRD[i] && RD[i] != 0)
         (m_poRD[i])->writeData(RD[i]);
     }
     sendOutputEvent(scm_nEventINDID);
     break;
   case scm_nEventRSPID:
        // TODO: do something !!!!!!!!!!!
     break;
   default:
     ;
   }
}

GEN_SUBL::GEN_SUBL(CStringDictionary::TStringId pa_nAppl, CResource *pa_poSrcRes):
          CLocalCommFB(pa_nAppl, pa_poSrcRes, &scm_stFBInterfaceSpec,m_apoEOConns){
  setEventChainExecutor(pa_poSrcRes->getResourceEventExecution());
  m_stEventSourceEventEntry.m_poFB = this;



}

GEN_SUBL::~GEN_SUBL(){
  unregisterSublFB(m_sID);
}
