/*******************************************************************************
 * Copyright (c) 2007 4DIAC - consortium.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     <date>: <author>, <author email> - changes
 *    20071029: az, alil@users.sourceforge.net - fixed bug in delte of data in the destructor
 *******************************************************************************/
#include <string.h>
#include "GEN_SUBSCRIBE.h"
#include "../../core/resource.h"

DEFINE_GENERIC_FB(GEN_SUBSCRIBE)

const TFBNameListEntry GEN_SUBSCRIBE::scm_acEventInputNames[2] = {"INIT", "RSP"};
const TFBNameListEntry GEN_SUBSCRIBE::scm_acEventOutputNames[2] = {"INITO", "IND"};
const TINT16 GEN_SUBSCRIBE::scm_anEIWidthIndexes[2] = {-1, -1};
const TINT16 GEN_SUBSCRIBE::scm_anEOWidthIndexes[3] = {-1, -1, -1};



const SFBInterfaceSpec GEN_SUBSCRIBE::scm_stFBInterfaceSpec = { \
  2, \
  scm_acEventInputNames, \
  0, \
  scm_anEIWidthIndexes, \
  2, \
  scm_acEventOutputNames, \
  0, \
  scm_anEOWidthIndexes, \
  0, \
  0, \
  0, \
  0
};

const TEventID GEN_SUBSCRIBE::scm_nEventINITID = 0;
const TEventID GEN_SUBSCRIBE::scm_nEventRSPID = 1;
const TEventID GEN_SUBSCRIBE::scm_nEventINITOID = 0;
const TEventID GEN_SUBSCRIBE::scm_nEventINDID = 1;

const int GEN_SUBSCRIBE::scm_nRecvBufferSize = 200; //TODO: Check this value!

void  GEN_SUBSCRIBE::executeEvent(TEventID pa_nEIID){
int result;
  QO=QI;
 // TODO: Check return values of the called functions and set correct Status Message
  switch(pa_nEIID) {
    case scm_nEventINITID:
      if (0 != m_poQI)
          m_poQI->readData(&QI);
      if (0 != m_poID)
          m_poID->readData(&ID);
      QO = QI;
      if (QI == true){ //INIT+
        //connect the SIFB to the socket handler
        strncpy(stConnectionInformation.m_pcConnectionID, ID, 31);
        stConnectionInformation.m_pcConnectionID[31] = '\0';
        if (m_roSocketHandler.registerSocketFB(stConnectionInformation) != 0) {
          STATUS=scm_sResponseTexts[0]; //OK
        } else {
          QO = false;
          STATUS=scm_sResponseTexts[2]; // TERMINATED
        }
      }
      else { //INIT-
        //disconnect the SIFB from the socket handler
        if (m_roSocketHandler.unregisterSocketFB(this) == 0)
          STATUS=scm_sResponseTexts[0]; //OK
        else
          STATUS=scm_sResponseTexts[2]; //TERMINATED
      }
      if (0 != m_poQO)
        m_poQO->writeData(&QO);
      if (0 != m_poSTATUS)
        m_poSTATUS->writeData(&STATUS);
      sendOutputEvent(scm_nEventINITOID);
      break;
   case cg_nExternalEventID:
     result = receiveData();
     if (result == 0) {
       QO = true;
       STATUS = scm_sResponseTexts[0]; //OK
     } else{
       QO = false;
       if (result == 1) {
           // TODO: Handle this ?
       } else
         STATUS=scm_sResponseTexts[4]; //DATA_TYPE_ERROR
     }
     if (0 != m_poQO)
       m_poQO->writeData(&QO);
     if (0 != m_poSTATUS)
       m_poSTATUS->writeData(&STATUS);
     for (unsigned int i=0;i<m_nNumDataOutput;i++) {
       if (0 != m_poRD[i] && RD[i] != 0)
         (m_poRD[i])->writeData(RD[i]);
     }
     sendOutputEvent(scm_nEventINDID);
     break;
   case scm_nEventRSPID:
        // TODO: do something !!!!!!!!!!!
      break;
   default:
     ;
   }
}

GEN_SUBSCRIBE::GEN_SUBSCRIBE(CStringDictionary::TStringId pa_nAppl, CResource *pa_poSrcRes):
          CNetCommFB(pa_nAppl, pa_poSrcRes, &scm_stFBInterfaceSpec,m_apoEOConns){
  setEventChainExecutor(pa_poSrcRes->getResourceEventExecution());
  m_stEventSourceEventEntry.m_poFB = this;

  stRecvBuffer.m_pcData = new TBYTE[scm_nRecvBufferSize];
  if (stRecvBuffer.m_pcData == 0)
    DEVLOG_DEBUG(cg_nID_Subscribe, 0x01, "unable to allocate memory for recvbuffer\n");

  stRecvBuffer.m_nFilledSize = 0;
  stRecvBuffer.m_nMaxSize = scm_nRecvBufferSize;
  stRecvBuffer.m_enConnectionState = CSocketHandler::e_Unconnected;

  stConnectionInformation.m_poSocketFB = this;
  stConnectionInformation.m_pstSendBuffer = 0;
  stConnectionInformation.m_pstRecvBuffer = &stRecvBuffer;
  stConnectionInformation.m_enServiceType = CSocketHandler::e_Subscriber;
  strncpy(stConnectionInformation.m_pcConnectionID, "0.0.0.0:61499", 31);
}

GEN_SUBSCRIBE::~GEN_SUBSCRIBE(){
 m_roSocketHandler.unregisterSocketFB(this);
 delete[] stRecvBuffer.m_pcData;
}




