/*******************************************************************************
 * Copyright (c) 2007 4DIAC - consortium.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     <date>: <author>, <author email> - changes
 *******************************************************************************/
#ifndef _GEN_SUBSCRIBE_H_
#define _GEN_SUBSCRIBE_H_

#include "../netcommfb.h"

/*! \brief Implementation of the SUBSCRIBER SIFB.
 *
 * @author SMR
 * @version 20081121/mmm - minor changes due to elimination of ANY_FACADE
 * @version 20071029/az - fixed bug in delte of data in the destructor
 * @version 20060718/SMR - revised version
 * @version 20060619/SMR - Introduced new FB interface
 * @version 20060214/SMR - Initial version of the SUBSCRIBER
 */


class GEN_SUBSCRIBE : public CNetCommFB {
DECLARE_GENERIC_FB(GEN_SUBSCRIBE)

private:
  static const TFBNameListEntry scm_acEventInputNames[];
  static const TFBNameListEntry scm_acEventOutputNames[];

  static const TINT16 scm_anEIWidthIndexes[];
  static const TINT16 scm_anEOWidthIndexes[];

  static const SFBInterfaceSpec scm_stFBInterfaceSpec;
  TEventConnectionPtr m_apoEOConns[2];

  static const TEventID scm_nEventINITID;
  static const TEventID scm_nEventRSPID;
  static const TEventID scm_nEventINITOID;
  static const TEventID scm_nEventINDID;
  static const int scm_nRecvBufferSize;


public:
  GEN_SUBSCRIBE(CStringDictionary::TStringId pa_nAppl, CResource *pa_poSrcRes);
  virtual ~GEN_SUBSCRIBE();
  virtual void executeEvent(TEventID pa_nEIID);

};

#endif //_GEN_SUBSCRIBE_H_

