/*******************************************************************************
 * Copyright (c) 2007 4DIAC - consortium.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     <date>: <author>, <author email> - changes
 *******************************************************************************/
 #include "netcommfb.h"


int CNetCommFB::sendData(){
  stSendBuffer.m_nFilledSize = 0;
  // if we have no data inputs, we send only a event message
  if (m_nNumDataInput == 0){
    stSendBuffer.m_pcData[0] = 5;
    stSendBuffer.m_nFilledSize = 1;
  }
  else{
    for (unsigned int i=0;i<m_nNumDataInput;i++) { //TODO: check if pointer = 0
      if (0 != SD[i]) {
        if (packSendData(&stSendBuffer, (SD[i]))!= 0){
          return -1;
        }
      }
      else{
        return -1;
      }
    }
  }
  return  m_roSocketHandler.sendData(this);

}

int CNetCommFB::packSendData(CSocketHandler::SSharedData *pa_pstBuffer, CIEC_ANY *pa_poSD)
{
  /*int nRetVal = pa_poSD->serialize(&(pa_pstBuffer->m_pcData[pa_pstBuffer->m_nFilledSize]),
                                   pa_pstBuffer->m_nMaxSize - pa_pstBuffer->m_nFilledSize);*/
  int nRetVal = m_roSerDeser.serialize(&(pa_pstBuffer->m_pcData[pa_pstBuffer->m_nFilledSize]),
      pa_pstBuffer->m_nMaxSize - pa_pstBuffer->m_nFilledSize,pa_poSD);

  if (nRetVal == -1)
      //TODO : sendbuffer Full, some handling here ?
    return -1;
  pa_pstBuffer->m_nFilledSize += nRetVal;
  return 0;
}

int CNetCommFB::receiveData()
{
  int retval;
  m_nRDpos = 0;
  TBYTE *BUFpos;
  BUFpos = stRecvBuffer.m_pcData;

   // check if the connection was closed by the client
  if (stRecvBuffer.m_enConnectionState == CSocketHandler::e_ClosedByClient) {
  	return 1 ;
  }
  if (m_nNumDataOutput == 0){
    if (stRecvBuffer.m_pcData[0] == 5 ) // we just send an output event
      m_roSocketHandler.receivedData(this);
    else {
      m_roSocketHandler.receivedData(this);
      DEVLOG_ERROR(cg_nID_CNetCommFB, 0x01, "COMMFB: No Output events and received wrong ASN1 Code!\n");
      return -1;
    }
  }
  else
    while(1) {  //loop for going through all Outputs
      if (RD[m_nRDpos]==0) {
        break;
      }
      //retval = (RD[m_nRDpos])->deserialize((TBYTE*) BUFpos, stRecvBuffer.m_nFilledSize);
      retval = m_roSerDeser.deserialize((TBYTE*) BUFpos, stRecvBuffer.m_nFilledSize, (RD[m_nRDpos]));
      if (retval==0) {
        //TODO: Handle Partial Sends!
        DEVLOG_ERROR(cg_nID_CNetCommFB, 0x01, "RECEIVED FRAGMENTED PACKET!-- not handled!\n");
        m_roSocketHandler.receivedData(this);
        return 0;
      }
      if (retval==-1) {
        m_nRDpos = 0;
        m_roSocketHandler.receivedData(this);
        //TODO Check if m_roSocketHandler.receivedData(this); is needed here
        return -1; // TODO : Handle this Error / Data for wrong Type received.
      }
      if (retval > 0) { //else
        stRecvBuffer.m_nFilledSize -= retval;
        BUFpos += retval;
      }
      if (++m_nRDpos==m_nNumDataOutput) {
        m_nRDpos = 0;
        m_roSocketHandler.receivedData(this);
        break;
      }
    }
    return 0;
  }
