/*******************************************************************************
 * Copyright (c) 2007 4DIAC - consortium.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     <date>: <author>, <author email> - changes
 *******************************************************************************/
#ifndef _NETCOMMFB_H_
#define _NETCOMMFB_H_

#include "./commfb.h"
#include "../arch/sochand.h"
#include "../core/serializer/ISerDeser.h"
#include "../core/serializer/CITASerDeser.h"
/*! \brief Base class for all Network FB.
 *
 * @author SMR
 * @version 20090105/mmm - added CITASerDeser* m_pCSerDeser, changed constructor instructions for getting
 *   Serializer/Deserializer, changed packSendData and recieveData due to new Serializer/Deserializer
 * @version 20081123/mmm - changes in sendData due to elimination of ANY_FACADE
 * @version 20070913/AZ - Added m_roSocketHandler.receivedData(this); in the case the datatype couldn't be decoded, otherwise the sockethanlder behaved odd.
 */
class CNetCommFB : public CCommFB {

private:
//! variable holding the current pos in the RD vector when recieving data
  int m_nRDpos;
 /*!\brief helper function for serializing all SD_x inputs the sendbuffer
 */
  int packSendData(CSocketHandler::SSharedData *pa_pstBuffer, CIEC_ANY *pa_poRD);

  //!< Serializer
  ISerDeser &m_roSerDeser;

protected:
 /*!reference to the SocketHandler used by the network communication FBs
 */
  CSocketHandler &m_roSocketHandler;

 /*! Shared Memory between the FB and the Sockethandler
 */
  CSocketHandler::SSharedData stSendBuffer;
 /*! Shared Memory between the FB and the Sockethandler
 */
  CSocketHandler::SSharedData stRecvBuffer;
 /*! Structure holding the whole connection information from one FB
 */
  CSocketHandler::SConnectionInformation stConnectionInformation;

/*!\brief function for recieving data from the socket handler
 */
  int receiveData();
/*!\brief function for sending data via the socket handler
 */
  int sendData();

public:
  CNetCommFB(CStringDictionary::TStringId pa_nAppl, CResource *pa_poSrcRes, const  SFBInterfaceSpec *pa_stFBInterfaceSpec, TEventConnectionPtr *pa_apoEOConns) : CCommFB(pa_nAppl, pa_poSrcRes, pa_stFBInterfaceSpec, pa_apoEOConns),
          m_roSerDeser(CITASerDeser::getInstance()),
          m_roSocketHandler(CSocketHandler::getInstance()){
  };
  virtual ~CNetCommFB() {
  };
};

#endif //_NETCOMMFB_H_
