/*************************************************************************
 *** FORTE Library Element
 ***
 *** Name: RT_E_CYCLE
 *** Description: Delayed propagation of an event-Cancellable
 *** Version: 
 ***     0.0: 2008-07-10/4DIAC-IDE - 4DIAC-Consortium
 *************************************************************************/

#ifndef _RT_E_CYCLE_H_
#define _RT_E_CYCLE_H_

#include <esfb.h>
#include <ecet.h>
#include <forte_usint.h>
#include <forte_bool.h>
#include <forte_array.h>
#include "../arch/timerha.h"


class RT_E_CYCLE: public CEventSourceFB{
  DECLARE_FIRMWARE_FB(RT_E_CYCLE)

private:
  static const TFBNameListEntry scm_acDataInputNames[];
  CIEC_TIME DT;
  CIEC_TIME Deadline;
  CIEC_TIME WCET;
  static const TFBNameListEntry scm_acDataOutputNames[];
  CIEC_BOOL QO;
  
  static const TEventID scm_nEventSTARTID;
    static const TEventID scm_nEventSTOPID;
  static const TINT16 scm_anEIWithIndexes[];
  static const TDataIOID scm_anEIWith[];
  static const TFBNameListEntry scm_acEventInputNames[];

  static const TEventID scm_nEventEOID;
  static const TINT16 scm_anEOWithIndexes[];
  static const TDataIOID scm_anEOWith[];
  static const TFBNameListEntry scm_acEventOutputNames[];
  static const SFBInterfaceSpec scm_stFBInterfaceSpec;

  TEventConnectionPtr m_apoEOConns[1];
  TDataConnectionPtr m_apoDIConns[3];
  TIEC_ANYPtr m_apoDIs[3];
  TDataConnectionPtr m_apoDOConns[1];
  TIEC_ANYPtr m_apoDOs[1];
  
  bool m_bActive; //!> flag to indicate that the timed fb is currently active
  STimedFBListEntry m_stTimeListEntry;
  CEventChainExecutionThread m_oECEO;
protected:
  virtual void executeEvent(TEventID pa_nEIID);
  
public:
  RT_E_CYCLE(CStringDictionary::TStringId pa_nAppl, CResource *pa_poSrcRes);
  virtual ~RT_E_CYCLE(){
    m_oECEO.setDeadline(0);
  };

};

#endif //close the ifdef sequence from the beginning of the file

