/*************************************************************************
 *** FORTE Library Element
 ***
 *** Name: RT_E_DEMUX
 *** Description: Event demultiplexer
 *** Version: 
 ***     0.0: 2008-07-10/4DIAC-IDE - 4DIAC-Consortium
 *************************************************************************/

#include "RT_E_DEMUX.h"

DEFINE_FIRMWARE_FB(RT_E_DEMUX)

const TFBNameListEntry RT_E_DEMUX::scm_acDataInputNames[] = {"QI", "K", "Tmin", "Deadline", "WCET"};

const TFBNameListEntry RT_E_DEMUX::scm_acDataOutputNames[] = {"QO"};

const TEventID RT_E_DEMUX::scm_nEventINITID = 0;
const TEventID RT_E_DEMUX::scm_nEventEIID = 1;
const TINT16 RT_E_DEMUX::scm_anEIWithIndexes[] = {0, 11};
const TDataIOID RT_E_DEMUX::scm_anEIWith[] = {0, 2, 3, 4, 5, 6, 7, 8, 9, 10, 255, 1, 255};
const TFBNameListEntry RT_E_DEMUX::scm_acEventInputNames[] = {"INIT", "EI"};

const TEventID RT_E_DEMUX::scm_nEventINITOID = 0;
const TEventID RT_E_DEMUX::scm_nEventEO0ID = 1;
const TEventID RT_E_DEMUX::scm_nEventEO1ID = 2;
const TEventID RT_E_DEMUX::scm_nEventEO2ID = 3;
const TEventID RT_E_DEMUX::scm_nEventEO3ID = 4;
const TDataIOID RT_E_DEMUX::scm_anEOWith[] = {0, 255};
const TINT16 RT_E_DEMUX::scm_anEOWithIndexes[] = {0, -1, -1, -1, -1, -1};
const TFBNameListEntry RT_E_DEMUX::scm_acEventOutputNames[] = {"INITO", "EO0", "EO1", "EO2", "EO3"};

const SFBInterfaceSpec RT_E_DEMUX::scm_stFBInterfaceSpec = {
  2,
  scm_acEventInputNames,
  scm_anEIWith,
  scm_anEIWithIndexes,
  5,
  scm_acEventOutputNames,
  scm_anEOWith,
  scm_anEOWithIndexes,
  11,
  scm_acDataInputNames,
  1,
  scm_acDataOutputNames
};

RT_E_DEMUX::RT_E_DEMUX(CStringDictionary::TStringId pa_nAppl, CResource *pa_poSrcRes) : 
       CServiceInterfaceFB(pa_nAppl,
           pa_poSrcRes,
           &scm_stFBInterfaceSpec,
           m_apoEOConns,
           m_apoDIConns,
           m_apoDIs,
           m_apoDOConns,
           m_apoDOs) {
  m_apoDIs[0] = &QI;
  m_apoDIs[1] = &K;
  m_apoDIs[2] = &Tmin;
  m_apoDIs[3] = &Deadline;
  m_apoDIs[4] = &WCET;
  m_apoDOs[0] = &QO;

    m_bInitialized = false;
}
 
void RT_E_DEMUX::executeEvent(TEventID pa_nEIID){

   if(scm_nEventEIID == pa_nEIID){
    if(m_bInitialized){
      switch(K){
        case 0:
            if(0 != m_apoEOConns[scm_nEventEO0ID]){
          	  m_apoEOConns[scm_nEventEO0ID]->triggerEvent(m_oECEO0);
              m_oECEO0.resumeSelfSuspend();
            }
          break;
        case 1:
            if(0 != m_apoEOConns[scm_nEventEO1ID]){
          	  m_apoEOConns[scm_nEventEO1ID]->triggerEvent(m_oECEO0);
              m_oECEO0.resumeSelfSuspend();
            }
          break;
        case 2:
            if(0 != m_apoEOConns[scm_nEventEO2ID]){
          	  m_apoEOConns[scm_nEventEO2ID]->triggerEvent(m_oECEO0);
              m_oECEO0.resumeSelfSuspend();
            }
          break;
        case 3:
          if(0 != m_apoEOConns[scm_nEventEO3ID]){
        	  m_apoEOConns[scm_nEventEO3ID]->triggerEvent(m_oECEO0);
            m_oECEO0.resumeSelfSuspend();
          }
          break;
        default:
          break;
      }
   } 
  }
  else
	  if(scm_nEventINITID == pa_nEIID){
      if(QI == true){
        if(!m_bInitialized){
          m_oECEO0.start();
          m_bInitialized = true;
        }
        m_oECEO0.setDeadline(Deadline);
      }
      else{
        m_oECEO0.end();  
        m_bInitialized = false;  
      }
    } 
}


