/*************************************************************************
 *** FORTE Library Element
 ***
 *** Name: RT_E_DEMUX
 *** Description: Event demultiplexer
 *** Version: 
 ***     0.0: 2008-07-10/4DIAC-IDE - 4DIAC-Consortium
 *************************************************************************/

#ifndef _RT_E_DEMUX_H_
#define _RT_E_DEMUX_H_

#include <sifb.h>
#include <ecet.h>
#include <forte_time.h>
#include <forte_usint.h>
#include <forte_uint.h>
#include <forte_bool.h>
#include <forte_array.h>

class RT_E_DEMUX: public CServiceInterfaceFB{
  DECLARE_FIRMWARE_FB(RT_E_DEMUX)

private:
  static const TFBNameListEntry scm_acDataInputNames[];
  CIEC_BOOL QI;
  CIEC_UINT K;
  CIEC_TIME Tmin;
  CIEC_TIME Deadline;
  CIEC_TIME WCET;

  static const TFBNameListEntry scm_acDataOutputNames[];
  CIEC_BOOL QO;
  static const TEventID scm_nEventINITID;
  static const TEventID scm_nEventEIID;
  static const TINT16 scm_anEIWithIndexes[];
  static const TDataIOID scm_anEIWith[];
  static const TFBNameListEntry scm_acEventInputNames[];

  static const TEventID scm_nEventINITOID;
  static const TEventID scm_nEventEO0ID;
  static const TEventID scm_nEventEO1ID;
  static const TEventID scm_nEventEO2ID;
  static const TEventID scm_nEventEO3ID;
  static const TINT16 scm_anEOWithIndexes[];
  static const TDataIOID scm_anEOWith[];
  static const TFBNameListEntry scm_acEventOutputNames[];

  static const SFBInterfaceSpec scm_stFBInterfaceSpec;

  TEventConnectionPtr m_apoEOConns[5];
  TDataConnectionPtr m_apoDIConns[11];
  TIEC_ANYPtr m_apoDIs[11];
  TDataConnectionPtr m_apoDOConns[1];
  TIEC_ANYPtr m_apoDOs[1];

  CEventChainExecutionThread m_oECEO0;
  bool m_bInitialized;
  
protected:  
  virtual void executeEvent(TEventID pa_nEIID);
  
  
public:
  RT_E_DEMUX(CStringDictionary::TStringId pa_nAppl, CResource *pa_poSrcRes);
  virtual ~RT_E_DEMUX(){};

};

#endif //close the ifdef sequence from the beginning of the file

