/*************************************************************************
 *** FORTE Library Element
 ***
 *** Name: RT_E_EC_COUPLER
 *** Description: Coupling two succeeding event chains
 *** Version: 
 ***     0.0: 2008-07-10/4DIAC-IDE - 4DIAC-Consortium
 *************************************************************************/

#include "RT_E_EC_COUPLER.h"

DEFINE_FIRMWARE_FB(RT_E_EC_COUPLER)

const TFBNameListEntry RT_E_EC_COUPLER::scm_acDataInputNames[] = {"QI", "Tmin", "Deadline"};

const TFBNameListEntry RT_E_EC_COUPLER::scm_acDataOutputNames[] = {"QO"};

const TEventID RT_E_EC_COUPLER::scm_nEventINITID = 0;
const TEventID RT_E_EC_COUPLER::scm_nEventEIID = 1;
const TINT16 RT_E_EC_COUPLER::scm_anEIWithIndexes[] = {0, -1};
const TDataIOID RT_E_EC_COUPLER::scm_anEIWith[] = {0, 1, 2, 255};
const TFBNameListEntry RT_E_EC_COUPLER::scm_acEventInputNames[] = {"INIT", "EI"};

const TEventID RT_E_EC_COUPLER::scm_nEventINITOID = 0;
const TEventID RT_E_EC_COUPLER::scm_nEventEOID = 1;
const TDataIOID RT_E_EC_COUPLER::scm_anEOWith[] = {0, 255};
const TINT16 RT_E_EC_COUPLER::scm_anEOWithIndexes[] = {0, -1, -1};
const TFBNameListEntry RT_E_EC_COUPLER::scm_acEventOutputNames[] = {"INITO", "EO"};

const SFBInterfaceSpec RT_E_EC_COUPLER::scm_stFBInterfaceSpec = {
  2,
  scm_acEventInputNames,
  scm_anEIWith,
  scm_anEIWithIndexes,
  2,
  scm_acEventOutputNames,
  scm_anEOWith,
  scm_anEOWithIndexes,
  3,
  scm_acDataInputNames,
  1,
  scm_acDataOutputNames
};

RT_E_EC_COUPLER::RT_E_EC_COUPLER(CStringDictionary::TStringId pa_nAppl, CResource *pa_poSrcRes) : 
       CRTEventSingle(pa_nAppl,
           pa_poSrcRes,
           &scm_stFBInterfaceSpec,
           m_apoEOConns,
           m_apoDIConns,
           m_apoDIs,
           m_apoDOConns,
           m_apoDOs,
          &Deadline) {
  m_apoDIs[0] = &QI;
  m_apoDIs[1] = &Tmin;
  m_apoDIs[2] = &Deadline;
  m_apoDOs[0] = &QO;
}
 



