/*************************************************************************
 *** FORTE Library Element
 ***
 *** Name: RT_E_EC_COUPLER
 *** Description: Coupling two succeeding event chains
 *** Version: 
 ***     0.0: 2008-07-10/4DIAC-IDE - 4DIAC-Consortium
 *************************************************************************/

#ifndef _RT_E_EC_COUPLER_H_
#define _RT_E_EC_COUPLER_H_

#include "rtesingle.h"
#include <forte_time.h>
#include <forte_bool.h>
#include <forte_array.h>

class RT_E_EC_COUPLER: public CRTEventSingle{
  DECLARE_FIRMWARE_FB(RT_E_EC_COUPLER)

private:
  static const TFBNameListEntry scm_acDataInputNames[];
  CIEC_BOOL QI;
  CIEC_TIME Tmin;
  CIEC_TIME Deadline;
  static const TFBNameListEntry scm_acDataOutputNames[];
  CIEC_BOOL QO;
  
  static const TEventID scm_nEventINITID;
  static const TEventID scm_nEventEIID;
  static const TINT16 scm_anEIWithIndexes[];
  static const TDataIOID scm_anEIWith[];
  static const TFBNameListEntry scm_acEventInputNames[];

  static const TEventID scm_nEventINITOID;
  static const TEventID scm_nEventEOID;
  static const TINT16 scm_anEOWithIndexes[];
  static const TDataIOID scm_anEOWith[];
  static const TFBNameListEntry scm_acEventOutputNames[];

  static const SFBInterfaceSpec scm_stFBInterfaceSpec;

  TEventConnectionPtr m_apoEOConns[2];
  TDataConnectionPtr m_apoDIConns[3];
  TIEC_ANYPtr m_apoDIs[3];
  TDataConnectionPtr m_apoDOConns[1];
  TIEC_ANYPtr m_apoDOs[1];

protected:
  virtual bool checkActivation(TEventID ) {return true;};
  
public:
  RT_E_EC_COUPLER(CStringDictionary::TStringId pa_nAppl, CResource *pa_poSrcRes);
  virtual ~RT_E_EC_COUPLER(){};

};

#endif //close the ifdef sequence from the beginning of the file

