/*************************************************************************
 *** FORTE Library Element
 ***
 *** Name: RT_E_PERMIT
 *** Description: Permissive propagation of an event
 *** Version: 
 ***     0.0: 2008-07-10/4DIAC-IDE - 4DIAC-Consortium
 *************************************************************************/

#include "RT_E_PERMIT.h"

DEFINE_FIRMWARE_FB(RT_E_PERMIT)

const TFBNameListEntry RT_E_PERMIT::scm_acDataInputNames[] = {"QI", "PERMIT", "Tmin", "Deadline", "WCET"};

const TFBNameListEntry RT_E_PERMIT::scm_acDataOutputNames[] = {"QO"};

const TEventID RT_E_PERMIT::scm_nEventINITID = 0;
const TEventID RT_E_PERMIT::scm_nEventEIID = 1;
const TINT16 RT_E_PERMIT::scm_anEIWithIndexes[] = {0, 5};
const TDataIOID RT_E_PERMIT::scm_anEIWith[] = {0, 2, 3, 4, 255, 1, 255};
const TFBNameListEntry RT_E_PERMIT::scm_acEventInputNames[] = {"INIT", "EI"};

const TEventID RT_E_PERMIT::scm_nEventINITOID = 0;
const TEventID RT_E_PERMIT::scm_nEventEOID = 1;
const TDataIOID RT_E_PERMIT::scm_anEOWith[] = {0, 255};
const TINT16 RT_E_PERMIT::scm_anEOWithIndexes[] = {0, -1, -1};
const TFBNameListEntry RT_E_PERMIT::scm_acEventOutputNames[] = {"INITO", "EO"};

const SFBInterfaceSpec RT_E_PERMIT::scm_stFBInterfaceSpec = {
  2,
  scm_acEventInputNames,
  scm_anEIWith,
  scm_anEIWithIndexes,
  2,
  scm_acEventOutputNames,
  scm_anEOWith,
  scm_anEOWithIndexes,
  5,
  scm_acDataInputNames,
  1,
  scm_acDataOutputNames
};

RT_E_PERMIT::RT_E_PERMIT(CStringDictionary::TStringId pa_nAppl, CResource *pa_poSrcRes) : 
       CRTEventSingle(pa_nAppl,
           pa_poSrcRes,
           &scm_stFBInterfaceSpec,
           m_apoEOConns,
           m_apoDIConns,
           m_apoDIs,
           m_apoDOConns,
           m_apoDOs,
           &Deadline) {
  m_apoDIs[0] = &QI;
  m_apoDIs[1] = &PERMIT;
  m_apoDIs[2] = &Tmin;
  m_apoDIs[3] = &Deadline;
  m_apoDIs[4] = &WCET;
  m_apoDOs[0] = &QO;
}




