/*************************************************************************
 *** FORTE Library Element
 ***
 *** Name: RT_E_REND
 *** Description: Rendezvous of two events
 *** Version: 
 ***     0.0: 2008-07-10/4DIAC-IDE - 4DIAC-Consortium
 *************************************************************************/

#include "RT_E_REND.h"

DEFINE_FIRMWARE_FB(RT_E_REND)

const TFBNameListEntry RT_E_REND::scm_acDataInputNames[] = {"QI", "Tmin", "Deadline", "WCET"};

const TFBNameListEntry RT_E_REND::scm_acDataOutputNames[] = {"QO"};

const TEventID RT_E_REND::scm_nEventINITID = 0;
const TEventID RT_E_REND::scm_nEventEI1ID = 1;
const TEventID RT_E_REND::scm_nEventEI2ID = 2;
const TEventID RT_E_REND::scm_nEventRID = 3;
const TINT16 RT_E_REND::scm_anEIWithIndexes[] = {0, -1, -1, -1};
const TDataIOID RT_E_REND::scm_anEIWith[] = {0, 1, 2, 3, 255};
const TFBNameListEntry RT_E_REND::scm_acEventInputNames[] = {"INIT", "EI1", "EI2", "R"};

const TEventID RT_E_REND::scm_nEventINITOID = 0;
const TEventID RT_E_REND::scm_nEventEOID = 1;
const TDataIOID RT_E_REND::scm_anEOWith[] = {0, 255};
const TINT16 RT_E_REND::scm_anEOWithIndexes[] = {0, -1, -1};
const TFBNameListEntry RT_E_REND::scm_acEventOutputNames[] = {"INITO", "EO"};

const SFBInterfaceSpec RT_E_REND::scm_stFBInterfaceSpec = {
  4,
  scm_acEventInputNames,
  scm_anEIWith,
  scm_anEIWithIndexes,
  2,
  scm_acEventOutputNames,
  scm_anEOWith,
  scm_anEOWithIndexes,
  4,
  scm_acDataInputNames,
  1,
  scm_acDataOutputNames
};

RT_E_REND::RT_E_REND(CStringDictionary::TStringId pa_nAppl, CResource *pa_poSrcRes) : 
       CRTEventSingle(pa_nAppl,
           pa_poSrcRes,
           &scm_stFBInterfaceSpec,
           m_apoEOConns,
           m_apoDIConns,
           m_apoDIs,
           m_apoDOConns,
           m_apoDOs,
           &Deadline) {
  m_apoDIs[0] = &QI;
  m_apoDIs[1] = &Tmin;
  m_apoDIs[2] = &Deadline;
  m_apoDIs[3] = &WCET;
  m_apoDOs[0] = &QO;
}
 
bool RT_E_REND::checkActivation(TEventID pa_nEIID){
  bool bRetval = false;
  
  if(scm_nEventEI1ID == pa_nEIID){
    if(m_nState == 2)
      bRetval = true;
    else
      m_nState = 1;    
  }
  else
    if(scm_nEventEI2ID == pa_nEIID){
      if(m_nState == 1)
        bRetval = true;
      else
        m_nState = 2;   
    }
    else
      if(scm_nEventRID == pa_nEIID)
        m_nState = 0;
  
  return bRetval;
}




