/*************************************************************************
 *** FORTE Library Element
 ***
 *** Name: RT_E_R_TRIG
 *** Description: Boolean rising edge detection
 *** Version: 
 ***     0.0: 2008-07-10/4DIAC-IDE - 4DIAC-Consortium
 *************************************************************************/

#include "RT_E_R_TRIG.h"

DEFINE_FIRMWARE_FB(RT_E_R_TRIG)

const TFBNameListEntry RT_E_R_TRIG::scm_acDataInputNames[] = {"QI", "Tmin", "Deadline", "WCET"};

const TFBNameListEntry RT_E_R_TRIG::scm_acDataOutputNames[] = {"QO"};

const TEventID RT_E_R_TRIG::scm_nEventINITID = 0;
const TEventID RT_E_R_TRIG::scm_nEventEIID = 1;
const TINT16 RT_E_R_TRIG::scm_anEIWithIndexes[] = {0, 5};
const TDataIOID RT_E_R_TRIG::scm_anEIWith[] = {0, 1, 2, 3, 255, 0, 255};
const TFBNameListEntry RT_E_R_TRIG::scm_acEventInputNames[] = {"INIT", "EI"};

const TEventID RT_E_R_TRIG::scm_nEventINITOID = 0;
const TEventID RT_E_R_TRIG::scm_nEventEOID = 1;
const TDataIOID RT_E_R_TRIG::scm_anEOWith[] = {0, 255};
const TINT16 RT_E_R_TRIG::scm_anEOWithIndexes[] = {0, -1, -1};
const TFBNameListEntry RT_E_R_TRIG::scm_acEventOutputNames[] = {"INITO", "EO"};

const SFBInterfaceSpec RT_E_R_TRIG::scm_stFBInterfaceSpec = {
  2,
  scm_acEventInputNames,
  scm_anEIWith,
  scm_anEIWithIndexes,
  2,
  scm_acEventOutputNames,
  scm_anEOWith,
  scm_anEOWithIndexes,
  4,
  scm_acDataInputNames,
  1,
  scm_acDataOutputNames
};

RT_E_R_TRIG::RT_E_R_TRIG(CStringDictionary::TStringId pa_nAppl, CResource *pa_poSrcRes) : 
       CRTEventSingle(pa_nAppl,
           pa_poSrcRes,
           &scm_stFBInterfaceSpec,
           m_apoEOConns,
           m_apoDIConns,
           m_apoDIs,
           m_apoDOConns,
           m_apoDOs,
           &Deadline) {
  m_apoDIs[0] = &QI;
  m_apoDIs[1] = &Tmin;
  m_apoDIs[2] = &Deadline;
  m_apoDIs[3] = &WCET;
  m_apoDOs[0] = &QO;
  m_bWasHigh = false;
}
 
bool RT_E_R_TRIG::checkActivation(TEventID ){
  bool bRetval = false;
  
  if((QI == true)&&(!m_bWasHigh)){
    bRetval = true;
  }
  m_bWasHigh = QI;
  return bRetval;
}


