/*************************************************************************
 *** FORTE Library Element
 ***
 *** Name: RT_E_SELECT
 *** Description: Selection between two events
 *** Version: 
 ***     0.0: 2008-07-10/4DIAC-IDE - 4DIAC-Consortium
 *************************************************************************/

#ifndef _RT_E_SELECT_H_
#define _RT_E_SELECT_H_

#include "rtesingle.h"
#include <forte_time.h>
#include <forte_bool.h>
#include <forte_array.h>

class RT_E_SELECT: public CRTEventSingle{
  DECLARE_FIRMWARE_FB(RT_E_SELECT)

private:
  static const TFBNameListEntry scm_acDataInputNames[];
  CIEC_BOOL QI;
  CIEC_BOOL G;
  CIEC_TIME Tmin;
  CIEC_TIME Deadline;
  CIEC_TIME WCET;
  static const TFBNameListEntry scm_acDataOutputNames[];
  CIEC_BOOL QO;
  static const TEventID scm_nEventINITID;
  static const TEventID scm_nEventEI0ID;
  static const TEventID scm_nEventEI1ID;
  static const TINT16 scm_anEIWithIndexes[];
  static const TDataIOID scm_anEIWith[];
  static const TFBNameListEntry scm_acEventInputNames[];

  static const TEventID scm_nEventINITOID;
  static const TEventID scm_nEventEOID;
  static const TINT16 scm_anEOWithIndexes[];
  static const TDataIOID scm_anEOWith[];
  static const TFBNameListEntry scm_acEventOutputNames[];

  static const SFBInterfaceSpec scm_stFBInterfaceSpec;

  TEventConnectionPtr m_apoEOConns[2];
  TDataConnectionPtr m_apoDIConns[5];
  TIEC_ANYPtr m_apoDIs[5];
  TDataConnectionPtr m_apoDOConns[1];
  TIEC_ANYPtr m_apoDOs[1];

protected:
  virtual bool checkActivation(TEventID pa_nEIID){
    return (((scm_nEventEI0ID == pa_nEIID) && (G == false))||
            ((scm_nEventEI1ID == pa_nEIID) && (G == true)));
  };
  
public:
  RT_E_SELECT(CStringDictionary::TStringId pa_nAppl, CResource *pa_poSrcRes);
  virtual ~RT_E_SELECT(){};

};

#endif //close the ifdef sequence from the beginning of the file

