/*************************************************************************
 *** FORTE Library Element
 ***
 *** Name: RT_E_SPLIT
 *** Description: Split an event to two event chain branches
 *** Version: 
 ***     0.0: 2008-07-10/4DIAC-IDE - 4DIAC-Consortium
 *************************************************************************/

#ifndef _RT_E_SPLIT_H_
#define _RT_E_SPLIT_H_

#include <sifb.h>
#include <ecet.h>
#include <forte_time.h>
#include <forte_usint.h>
#include <forte_bool.h>
#include <forte_array.h>

class RT_E_SPLIT: public CServiceInterfaceFB{
  DECLARE_FIRMWARE_FB(RT_E_SPLIT)

private:
  static const TFBNameListEntry scm_acDataInputNames[];
  CIEC_BOOL QI;
  CIEC_TIME Tmin;
  CIEC_TIME Deadline_EO1;
  CIEC_TIME WCET_EO1;
  CIEC_TIME Deadline_EO2;
  CIEC_TIME WCET_EO2;
  static const TFBNameListEntry scm_acDataOutputNames[];
  CIEC_BOOL QO;
  static const TEventID scm_nEventINITID;
  static const TEventID scm_nEventEIID;
  static const TINT16 scm_anEIWithIndexes[];
  static const TDataIOID scm_anEIWith[];
  static const TFBNameListEntry scm_acEventInputNames[];

  static const TEventID scm_nEventINITOID;
  static const TEventID scm_nEventEO1ID;
  static const TEventID scm_nEventEO2ID;
  static const TINT16 scm_anEOWithIndexes[];
  static const TDataIOID scm_anEOWith[];
  static const TFBNameListEntry scm_acEventOutputNames[];

  static const SFBInterfaceSpec scm_stFBInterfaceSpec;

  TEventConnectionPtr m_apoEOConns[3];
  TDataConnectionPtr m_apoDIConns[6];
  TIEC_ANYPtr m_apoDIs[6];
  TDataConnectionPtr m_apoDOConns[1];
  TIEC_ANYPtr m_apoDOs[1];

  CEventChainExecutionThread m_oECEO1, m_oECEO2;
  bool m_bInitialized;
  
protected:  
  virtual void executeEvent(TEventID pa_nEIID);
  
public:
  RT_E_SPLIT(CStringDictionary::TStringId pa_nAppl, CResource *pa_poSrcRes);
  virtual ~RT_E_SPLIT(){};

};

#endif //close the ifdef sequence from the beginning of the file

