/*************************************************************************
 *** FORTE Library Element
 ***
 *** Name: AdapterTest_P
 *** Description: Composite Function Block Type
 *** Version: 
 ***     0.0: 2008-04-22/IH - ACIN - 
 *************************************************************************/

#include "AdapterTest_P.h"
#include <typelib.h>

DEFINE_FIRMWARE_FB(AdapterTest_P)

const TFBNameListEntry AdapterTest_P::scm_acDataInputNames[] = {"QI", "Sub1_addr", "Sub2_addr", "Pub1_addr", "Pub2_addr"};

const TFBNameListEntry AdapterTest_P::scm_acAdapterNames[] = {"myPlug"};
const TUINT8 AdapterTest_P::m_nNumAdapters = 1;

const TEventID AdapterTest_P::scm_nEventINITID = 0;
const TINT16 AdapterTest_P::scm_anEIWithIndexes[] = {0};
const TDataIOID AdapterTest_P::scm_anEIWith[] = {0, 1, 2, 3, 4, 255};
const TFBNameListEntry AdapterTest_P::scm_acEventInputNames[] = {"INIT"};

const TEventID AdapterTest_P::scm_nEventINITOID = 0;
const TINT16 AdapterTest_P::scm_anEOWithIndexes[] = {-1, -1};
const TFBNameListEntry AdapterTest_P::scm_acEventOutputNames[] = {"INITO"};

const SFBInterfaceSpec AdapterTest_P::scm_stFBInterfaceSpec = {
  1,
  scm_acEventInputNames,
  scm_anEIWith,
  scm_anEIWithIndexes,
  1,
  scm_acEventOutputNames,
  0,
  scm_anEOWithIndexes,
  5,
  scm_acDataInputNames,
  0,
  0
};

const TUINT16 AdapterTest_P::m_nNumInternalFBs = 4;

void AdapterTest_P::executeEvent(TEventID pa_nEIID){
  switch(pa_nEIID){
    case scm_nEventINITID:
      m_oEventConnection_INIT.triggerEvent(*m_poInvokingExecEnv);
      break;
  }
}

AdapterTest_P::AdapterTest_P(CStringDictionary::TStringId pa_nAppl, CResource *pa_poSrcRes) : 
       CCompositeFB(pa_nAppl,
           pa_poSrcRes,
           &scm_stFBInterfaceSpec,
           m_apoEOConns,
           m_apoDIConns,
           m_apoIf2InDConns,
           m_apoDIs,
           0,
           0,
           0,
           m_nNumInternalFBs,
           m_apoInternalFBs,
           m_nNumAdapters,
           m_apoAdapters),
       m_oEventConnection_PlugSend2_INITO("PlugSend2","INITO"),
       m_oEventConnection_PlugRec1_INITO("PlugRec1","INITO"),
       m_oEventConnection_PlugRec2_IND("PlugRec2","IND"),
       m_oEventConnection_PlugSend1_INITO("PlugSend1","INITO"),
       m_oEventConnection_INIT(0, "INIT"),
       m_oEventConnection_myPlug1_REQ("myPlug","REQ"),
       m_oEventConnection_PlugRec1_IND("PlugRec1","IND"),
       m_oEventConnection_myPlug1_RSP("myPlug","RSP"),
       m_oEventConnection_PlugRec2_INITO("PlugRec2","INITO"),
       m_oDataConnection_Pub1_addr("Pub1_addr",&Pub1_addr),
       m_oDataConnection_Sub2_addr("Sub2_addr",&Sub2_addr),
       m_oDataConnection_Sub1_addr("Sub1_addr",&Sub1_addr),
       m_oDataConnection_Pub2_addr("Pub2_addr",&Pub2_addr),
       m_oDataConnection_QI("QI",&QI),
       m_oDataConnection_myPlug1_RSPD("myPlug","RSPD"),
       m_oDataConnection_PlugRec1_RD_1("PlugRec1","RD_1"),
       m_oDataConnection_myPlug1_REQD("myPlug","REQD"),
       m_oDataConnection_PlugRec2_RD_1("PlugRec2","RD_1"),
       m_oDataConnection_PlugRec1_QO("PlugRec1","QO"),
       myPlug(pa_nAppl,pa_poSrcRes, "myPlug", true) {   // myPlug
  
  m_apoAdapters[0] = &myPlug;
       
  m_apoInternalFBs[0] = createContainedFB("PlugRec1", "SUBSCRIBE_1", pa_poSrcRes);    // PlugRec1
  m_apoInternalFBs[1] = createContainedFB("PlugRec2", "SUBSCRIBE_1", pa_poSrcRes);    // PlugRec2
  m_apoInternalFBs[2] = createContainedFB("PlugSend1", "PUBLISH_1", pa_poSrcRes);    // PlugSend1
  m_apoInternalFBs[3] = createContainedFB("PlugSend2", "PUBLISH_1", pa_poSrcRes);    // PlugSend2
    
  m_apoIf2InDConns[0] = &m_oDataConnection_QI;
  m_apoIf2InDConns[1] = &m_oDataConnection_Sub1_addr;
  m_apoIf2InDConns[2] = &m_oDataConnection_Sub2_addr;
  m_apoIf2InDConns[3] = &m_oDataConnection_Pub1_addr;
  m_apoIf2InDConns[4] = &m_oDataConnection_Pub2_addr;

  
  
  m_oEventConnection_INIT.connect("PlugRec1",*this,*m_apoInternalFBs[0],"INIT");
  m_oEventConnection_PlugSend2_INITO.connectInterfaceEvent(this,scm_nEventINITOID);
  m_apoInternalFBs[3]->connectEO("INITO",&m_oEventConnection_PlugSend2_INITO);
  m_oEventConnection_PlugRec1_INITO.connect("PlugRec2",*m_apoInternalFBs[0],*m_apoInternalFBs[1],"INIT");
  m_oEventConnection_PlugRec2_INITO.connect("PlugSend1",*m_apoInternalFBs[1],*m_apoInternalFBs[2],"INIT");
  m_oEventConnection_PlugSend1_INITO.connect("PlugSend2",*m_apoInternalFBs[2],*m_apoInternalFBs[3],"INIT");
  m_oEventConnection_PlugRec1_IND.connect("myPlug",*m_apoInternalFBs[0],*m_apoAdapters[0],"CNF");
  m_oEventConnection_PlugRec2_IND.connect("myPlug",*m_apoInternalFBs[1],*m_apoAdapters[0],"IND");
  m_oEventConnection_myPlug1_REQ.connect("PlugSend1",*m_apoAdapters[0],*m_apoInternalFBs[2],"REQ");
  m_oEventConnection_myPlug1_RSP.connect("PlugSend2",*m_apoAdapters[0],*m_apoInternalFBs[3],"REQ");

  m_oDataConnection_QI.connect("PlugRec1",*this,*m_apoInternalFBs[0],"QI");
  m_oDataConnection_Sub1_addr.connect("PlugRec1",*this,*m_apoInternalFBs[0],"ID");
  m_oDataConnection_Sub2_addr.connect("PlugRec2",*this,*m_apoInternalFBs[1],"ID");
  m_oDataConnection_QI.connect("PlugSend1",*this,*m_apoInternalFBs[2],"QI");
  m_oDataConnection_QI.connect("PlugSend2",*this,*m_apoInternalFBs[3],"QI");
  m_oDataConnection_Pub1_addr.connect("PlugSend1",*this,*m_apoInternalFBs[2],"ID");
  m_oDataConnection_Pub2_addr.connect("PlugSend2",*this,*m_apoInternalFBs[3],"ID");
  m_oDataConnection_PlugRec1_QO.connect("PlugRec2",*m_apoInternalFBs[0],*m_apoInternalFBs[1],"QI");
  m_oDataConnection_PlugRec2_RD_1.connect("myPlug",*m_apoInternalFBs[1],*m_apoAdapters[0],"INDD");
  m_oDataConnection_PlugRec1_RD_1.connect("myPlug",*m_apoInternalFBs[0],*m_apoAdapters[0],"CNFD");
  m_oDataConnection_myPlug1_REQD.connect("PlugSend1",*m_apoAdapters[0],*m_apoInternalFBs[2],"SD_1");
  m_oDataConnection_myPlug1_RSPD.connect("PlugSend2",*m_apoAdapters[0],*m_apoInternalFBs[3],"SD_1");

  m_apoDIs[0] = &QI;
  m_apoDIs[1] = &Sub1_addr;
  m_apoDIs[2] = &Sub2_addr;
  m_apoDIs[3] = &Pub1_addr;
  m_apoDIs[4] = &Pub2_addr;
}
 
AdapterTest_P::~AdapterTest_P(){
}



