/*************************************************************************
 *** FORTE Library Element
 ***
 *** Name: DECRYPT_2
 *** Description: Basic Function Block Type
 *** Version: 
 ***     1.0: 2006-11-14/TS - PROFACTOR GmbH - 
 *************************************************************************/

#ifndef _DECRYPT_2_H_
#define _DECRYPT_2_H_

#include <basicfb.h>
#include <forte_wstring.h>

class DECRYPT_2: public CBasicFB{
  DECLARE_FIRMWARE_FB(DECRYPT_2)

private:
  static const TFBNameListEntry scm_acDataInputNames[];
  CIEC_WSTRING INPUT;
  static const TFBNameListEntry scm_acDataOutputNames[];
  CIEC_WSTRING OUTPUT;
  static const TEventID scm_nEventREQID;
  static const TINT16 scm_anEIWithIndexes[];
  static const TDataIOID scm_anEIWith[];
  static const TFBNameListEntry scm_acEventInputNames[];

  static const TEventID scm_nEventCNFID;
  static const TINT16 scm_anEOWithIndexes[];
  static const TDataIOID scm_anEOWith[];
  static const TFBNameListEntry scm_acEventOutputNames[];

  static const SFBInterfaceSpec scm_stFBInterfaceSpec;

  TEventConnectionPtr m_apoEOConns[1];
  TDataConnectionPtr m_apoDIConns[1];
  TIEC_ANYPtr m_apoDIs[1];
  TDataConnectionPtr m_apoDOConns[1];
  TIEC_ANYPtr m_apoDOs[1];
  void alg_REQ(void);
  static const TINT16 scm_nStateSTART;
  static const TINT16 scm_nStateREQ;

  void enterStateSTART();
  void enterStateREQ();
 
protected:
  virtual bool executeECCOnce(TEventID pa_nEIID);

public:
  DECRYPT_2(CStringDictionary::TStringId pa_nAppl, CResource *pa_poSrcRes);
  virtual ~DECRYPT_2();

};

#endif //close the ifdef sequence from the beginning of the file

