/*************************************************************************
 *** FORTE Library Element
 ***
 *** Name: SocketTest_S
 *** Description: Composite Function Block Type
 *** Version: 
 ***     0.0: 2008-04-22/IH - ACIN - 
 *************************************************************************/

#ifndef _SocketTest_S_H_
#define _SocketTest_S_H_

#include <cfb.h>
#include <forte_wstring.h>
#include <forte_bool.h>
#include <forte_array.h>
#include "TestAdapter.h"

class SocketTest_S: public CCompositeFB{
  DECLARE_FIRMWARE_FB(SocketTest_S)

private:
  static const TFBNameListEntry scm_acDataInputNames[];
  CIEC_BOOL QI;
  CIEC_WSTRING Sub1_addr;
  CIEC_WSTRING Sub2_addr;
  CIEC_WSTRING Pub1_addr;
  CIEC_WSTRING Pub2_addr;
  static const TEventID scm_nEventINITID;
  static const TINT16 scm_anEIWithIndexes[];
  static const TDataIOID scm_anEIWith[];
  static const TFBNameListEntry scm_acEventInputNames[];

  static const TEventID scm_nEventINITOID;
  static const TINT16 scm_anEOWithIndexes[];
  static const TFBNameListEntry scm_acEventOutputNames[];

  static const SFBInterfaceSpec scm_stFBInterfaceSpec;

  TEventConnectionPtr m_apoEOConns[1];
  TDataConnectionPtr m_apoDIConns[5];
  TIEC_ANYPtr m_apoDIs[5];

  static const TUINT16 m_nNumInternalFBs;
  TFunctionBlockPtr m_apoInternalFBs[4];
  
  static const TFBNameListEntry scm_acAdapterNames[];
  static const TUINT8 m_nNumAdapters;
  TAdapterPtr m_apoAdapters[1];

  CInternal2InterfaceEventConnection m_oEventConnection_PlugSend2_INITO;
  CEventConnection m_oEventConnection_mySocket_IND;
  CEventConnection m_oEventConnection_PlugRec1_INITO;
  CEventConnection m_oEventConnection_PlugRec2_IND;
  CEventConnection m_oEventConnection_PlugSend1_INITO;
  CEventConnection m_oEventConnection_INIT;
  CEventConnection m_oEventConnection_PlugRec1_IND;
  CEventConnection m_oEventConnection_mySocket_CNF;
  CEventConnection m_oEventConnection_PlugRec2_INITO;

  CInterface2InternalDataConnection m_oDataConnection_Pub1_addr;
  CInterface2InternalDataConnection m_oDataConnection_Sub2_addr;
  CInterface2InternalDataConnection m_oDataConnection_Sub1_addr;
  CInterface2InternalDataConnection m_oDataConnection_Pub2_addr;
  CInterface2InternalDataConnection m_oDataConnection_QI;
  CDataConnection m_oDataConnection_mySocket_INDD;
  CDataConnection m_oDataConnection_PlugRec1_RD_1;
  CDataConnection m_oDataConnection_mySocket_CNFD;
  CDataConnection m_oDataConnection_PlugRec2_RD_1;
  CDataConnection m_oDataConnection_PlugRec1_QO;

  TESTADAPTER mySocket;
  
  TCInterface2InternalDataConnectionPtr m_apoIf2InDConns[5];
  TCInternal2InterfaceDataConnectionPtr m_apoIn2IfDConns[0];

protected:
  void executeEvent(TEventID pa_nEIID);

public:
  SocketTest_S(CStringDictionary::TStringId pa_nAppl, CResource *pa_poSrcRes);
  virtual ~SocketTest_S();

};

#endif //close the ifdef sequence from the beginning of the file

