/*******************************************************************************
 * Copyright (c) 2007 4DIAC - consortium.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     <date>: <author>, <author email> - changes
 *******************************************************************************/
#include "TestAdapter.h"

DEFINE_ADAPTER_TYPE(TESTADAPTER)

const TFBNameListEntry TESTADAPTER::scm_acDataInputNamesSocket[] = {"REQD","RSPD"};
const TFBNameListEntry TESTADAPTER::scm_acDataOutputNamesSocket[] = {"CNFD","INDD"};


const TEventID TESTADAPTER::scm_nEventEIIDSocket = 0;
const TINT16 TESTADAPTER::scm_anEIWithIndexesSocket[] = {0,2, -1};
const TDataIOID TESTADAPTER::scm_anEIWithSocket[] = {0, 255,1,255};
const TFBNameListEntry TESTADAPTER::scm_acEventInputNamesSocket[] = {"REQ","RSP"};

const TEventID TESTADAPTER::scm_nEventEOIDSocket = 0;
const TINT16 TESTADAPTER::scm_anEOWithIndexesSocket[] = {0,2, -1};
const TDataIOID TESTADAPTER::scm_anEOWithSocket[] = {0, 255,1,255};
const TFBNameListEntry TESTADAPTER::scm_acEventOutputNamesSocket[] = {"CNF","IND"};


const SFBInterfaceSpec TESTADAPTER::scm_stFBInterfaceSpecSocket = {
  2,
  scm_acEventInputNamesSocket,
  scm_anEIWithSocket,
  scm_anEIWithIndexesSocket,
  2,
  scm_acEventOutputNamesSocket,
  scm_anEOWithSocket,
  scm_anEOWithIndexesSocket,
  2,
  scm_acDataInputNamesSocket,
  2,
  scm_acDataOutputNamesSocket,
};
const SFBInterfaceSpec TESTADAPTER::scm_stFBInterfaceSpecPlug = {
  2,
  scm_acEventOutputNamesSocket,
  scm_anEOWithSocket,
  scm_anEOWithIndexesSocket,
  2,
  scm_acEventInputNamesSocket,
  scm_anEIWithSocket,
  scm_anEIWithIndexesSocket,
  2,
  scm_acDataOutputNamesSocket,
  2,
  scm_acDataInputNamesSocket,
};


TESTADAPTER::TESTADAPTER(CStringDictionary::TStringId pa_nAppl, CResource *pa_poSrcRes, const char *pa_acAdapterInstanceName, bool pa_bIsPlug) : 
       CAdapter(pa_nAppl, pa_poSrcRes, &scm_stFBInterfaceSpecSocket , m_apoEOConnsSocket, m_apoDIConnsSocket, m_apoDIsSocket, 
                m_apoDOConnsSocket, m_apoDOsSocket, &scm_stFBInterfaceSpecPlug, m_apoEOConnsPlug, pa_acAdapterInstanceName, pa_bIsPlug){
  
  if (pa_bIsPlug){
    m_apoDOs[0] = &REQD;
    m_apoDOs[1] = &RSPD;
    m_apoDIs[0] = &CNFD;
    m_apoDIs[1] = &INDD;
  }
  else {
    m_apoDIs[0] = &REQD;
    m_apoDIs[1] = &RSPD;
    m_apoDOs[0] = &CNFD;
    m_apoDOs[1] = &INDD;
  }
}
 
TESTADAPTER::~TESTADAPTER(){
}



