/*******************************************************************************
 * Copyright (c) 2007 4DIAC - consortium.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     <date>: <author>, <author email> - changes
 *******************************************************************************/
 
 /*! \mainpage FORTE - Framework for Distributed Industrial Automation and Control Run-Time Environment
 *
 * This is the documenation of FORTE. Here you can find the information on how FORTE is composed and how
 * to port it to other architectures.
 * 
 * \section intro_sec Introduction
 *
 * This is the introduction.
 *
 * \section install_sec Installation
 * How to compile, install and run FORTE on a specific platform.
 * 
 * \section overview_sec Overview
 * Describes the codestructure and stuff of FORTE
 *
 * \section porting_sec Porting FORTE
 * 
 */  

#ifndef _FORTE_H_
#define _FORTE_H_

class CDevice;

//!Start up forte and execute 1499 applications. 
/*! This function will return and depending on the platform specific means have to be 
 * taken in order to detect the runtime state. See platform specific implemenations for examples.
 */
int forteMain(CDevice &pa_roDev);

#endif /*_FORTE_H_*/
